/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 32);
/******/ })
/************************************************************************/
/******/ ({

/***/ 1:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = openURL;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_debug__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_debug___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_debug__);




var debugMsg = __WEBPACK_IMPORTED_MODULE_0_debug___default()('message');

const messageListeners = new Map();

const storageListeners = new Map();

const storage = {
  sync: {
    clear: storageClear('sync'),
    remove: storageRemove('sync'),
    get: storageGet('sync'),
    set: storageSet('sync'),
    listen: storageListen('sync'),
    addListener: storageListen('sync'),
    on: storageListen('sync')
  },
  local: {
    clear: storageClear('local'),
    remove: storageRemove('local'),
    get: storageGet('local'),
    set: storageSet('local'),
    listen: storageListen('local'),
    addListener: storageListen('local'),
    on: storageListen('local')
  },
  listen: storageListen(),
  addListener: storageListen(),
  on: storageListen(),

  off: storageStopListen,
  removeListener: storageStopListen
};
/* harmony export (immutable) */ __webpack_exports__["c"] = storage;


const message = {
  send: messageSend,
  fire: messageSend,
  emit: messageSend,

  listen: messageListen,
  addListener: messageListen,
  on: messageListen,

  off: messageStopListen,
  removeListener: messageStopListen,

  server: initServer,

  self: {
    send: messageSendSelf,
    fire: messageSendSelf,
    emit: messageSendSelf,

    listen: messageListenSelf,
    addListener: messageListenSelf,
    on: messageListenSelf,

    off: messageStopListen,
    removeListener: messageStopListen
  }
};
/* harmony export (immutable) */ __webpack_exports__["a"] = message;


function openURL(url, callback) {
  if (typeof url !== 'string') {
    throw new TypeError('arg 1 should be a string');
  }
  if (callback) {
    return _openURL(url, callback);
  } else {
    return new Promise(resolve => _openURL(url, resolve));
  }
}

/* unused harmony default export */ var _unused_webpack_default_export = ({
  openURL,
  storage,
  message
});

function storageGet(storageArea) {
  return function get(keys, cb) {
    if (typeof keys === 'function') {
      cb = keys;
      return chrome.storage[storageArea].get(cb);
    } else if (typeof cb === 'function') {
      return chrome.storage[storageArea].get(keys, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].get(keys, data => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve(data);
          }
        });
      });
    }
  };
}

function storageSet(storageArea) {
  return function set(items, cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].set(items, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].set(items, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function storageListen(storageArea) {
  return function listen(key, cb) {
    if (typeof key === 'function') {
      cb = key;
      key = '';
    }
    if (typeof key !== 'string') {
      throw new TypeError('Argument 1 should be string when argument 2 is a function.');
    }
    if (typeof cb !== 'function') {
      throw new TypeError('Callback should be a function.');
    }

    let listeners = storageListeners.get(cb);
    if (!listeners) {
      listeners = new Map();
      storageListeners.set(cb, listeners);
    }
    let callback = listeners.get(key);
    if (!callback) {
      callback = (changes, areaName) => {
        if (storageArea && areaName !== storageArea) {
          return;
        }
        if (!key || changes[key]) {
          cb(changes, areaName);
        }
      };
      listeners.set(key, callback);
    }
    return chrome.storage.onChanged.addListener(callback);
  };
}

function storageStopListen(listener, key) {
  const listeners = storageListeners.get(listener);
  if (listeners) {
    if (typeof key === 'string') {
      const callback = listeners.get(key);
      if (callback) {
        listeners.delete(key);
        if (listeners.size <= 0) {
          storageListeners.delete(listener);
        }
        return chrome.storage.onChanged.removeListener(callback);
      }
    } else {
      Array.from(listeners.values()).forEach(callback => {
        chrome.storage.onChanged.removeListener(callback);
      });
      storageListeners.delete(listener);
    }
  } else {
    return chrome.storage.onChanged.removeListener(listener);
  }
}

function storageClear(storageArea) {
  return function clear(cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].clear();
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].clear(() => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function storageRemove(storageArea) {
  return function remove(keys, cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].remove(keys, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].remove(keys, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function messageSend(...args) {
  if (args[0] === Object(args[0])) {
    let [message, cb] = args;
    if (typeof cb === 'function') {
      return chrome.runtime.sendMessage(message, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.runtime.sendMessage(message, response => {
          resolve(response);
        });
      });
    }
  }

  let [tabId, message, cb] = args;
  if (typeof cb === 'function') {
    return chrome.tabs.sendMessage(tabId, message, cb);
  } else {
    return new Promise((resolve, reject) => {
      chrome.tabs.sendMessage(tabId, message, response => {
        resolve(response);
      });
    });
  }
}

function messageListen(msg, cb) {
  if (typeof msg === 'function') {
    cb = msg;
    msg = '';
  }
  if (typeof msg !== 'string') {
    throw new TypeError('Argument 1 should be string when argument 2 is a function.');
  }
  if (typeof cb !== 'function') {
    throw new TypeError('Callback should be a function.');
  }

  let listeners = messageListeners.get(cb);
  if (!listeners) {
    listeners = new Map();
    messageListeners.set(cb, listeners);
  }
  let callback = listeners.get(msg);
  if (!callback) {
    callback = msg ? (message, sender, sendResponse) => {
      if (message && message.msg === msg) {
        return cb(message, sender, sendResponse);
      }
    } : cb;
    listeners.set(msg, callback);
  }
  return chrome.runtime.onMessage.addListener(callback);
}

function messageStopListen(listener, msg) {
  const listeners = messageListeners.get(listener);
  if (listeners) {
    if (typeof msg === 'string') {
      const callback = listeners.get(msg);
      if (callback) {
        listeners.delete(msg);
        if (listeners.size <= 0) {
          messageListeners.delete(listener);
        }
        return chrome.runtime.onMessage.removeListener(callback);
      }
    } else {
      Array.from(listeners.values()).forEach(callback => {
        chrome.runtime.onMessage.removeListener(callback);
      });
      messageListeners.delete(listener);
    }
  } else {
    return chrome.runtime.onMessage.removeListener(listener);
  }
}

function messageSendSelf(message, cb) {
  if (message !== Object(message)) {
    throw new TypeError('arg 1 should be an object');
  }

  message.msg = `_&_${message.msg}_&_`;
  if (typeof cb === 'function') {
    if (typeof window.pageId === 'undefined') {
      return chrome.runtime.sendMessage({ msg: '__PAGE_INFO__' }, ({ pageId, faviconURL, pageTitle, pageURL }) => {
        window.pageId = pageId;
        window.faviconURL = faviconURL;
        if (pageTitle) {
          window.pageTitle = pageTitle;
        }
        if (pageURL) {
          window.pageURL = pageURL;
        }
        message.__pageId__ = pageId;
        debugMsg('SELF send %s on %s (request page id)', message.msg, window.pageId);
        chrome.runtime.sendMessage(message, cb);
      });
    } else {
      message.__pageId__ = window.pageId;
      debugMsg('SELF send %s on %s', message.msg, window.pageId);
      return chrome.runtime.sendMessage(message, cb);
    }
  } else {
    if (typeof window.pageId === 'undefined') {
      return messageSend({ msg: '__PAGE_INFO__' }).then(({ pageId, faviconURL, pageTitle, pageURL }) => {
        window.pageId = pageId;
        window.faviconURL = faviconURL;
        if (pageTitle) {
          window.pageTitle = pageTitle;
        }
        if (pageURL) {
          window.pageURL = pageURL;
        }
        message.__pageId__ = pageId;
        debugMsg('SELF send %s on %s (request page id)', message.msg, window.pageId);
        return messageSend(message);
      });
    } else {
      message.__pageId__ = window.pageId;
      debugMsg('SELF send %s on %s', message.msg, window.pageId);
      return messageSend(message);
    }
  }
}

function messageListenSelf(msg, cb) {
  if (typeof window.pageId === 'undefined') {
    chrome.runtime.sendMessage({ msg: '__PAGE_INFO__' }, ({ pageId, faviconURL, pageTitle, pageURL }) => {
      window.pageId = pageId;
      window.faviconURL = faviconURL;
      if (pageTitle) {
        window.pageTitle = pageTitle;
      }
      if (pageURL) {
        window.pageURL = pageURL;
      }
    });
  }

  if (typeof msg === 'function') {
    cb = msg;
    msg = '';
  }
  if (typeof msg !== 'string') {
    throw new TypeError('Argument 1 should be string when argument 2 is a function.');
  }
  if (typeof cb !== 'function') {
    throw new TypeError('Callback should be a function.');
  }

  let listeners = messageListeners.get(cb);
  if (!listeners) {
    listeners = new Map();
    messageListeners.set(cb, listeners);
  }
  let callback = listeners.get(msg);
  if (!callback) {
    callback = (message, sender, sendResponse) => {
      if (message && window.pageId === message.__pageId__) {
        if (!msg || message.msg === msg) {
          debugMsg('SELF Received %s on %s', msg, window.pageId);
          return cb(message, sender, sendResponse);
        }
      }
    };
    listeners.set(msg, callback);
  }
  debugMsg('SELF Listening to %s on %s', msg, window.pageId);
  return chrome.runtime.onMessage.addListener(callback);
}

const selfMsgTester = /^_&_(.+)_&_$/;

function initServer() {
  window.pageId = 'background page';
  chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (!message) {
      return;
    }

    const selfMsg = selfMsgTester.exec(message.msg);
    if (selfMsg) {
      debugMsg('SELF Received %s from %s', message.msg, getPageInfo(sender).pageId);
      message.msg = selfMsg[1];
      if (sender.tab) {
        messageSend(sender.tab.id, message, response => {
          sendResponse(response);
        });
      } else {
        messageSend(message, response => {
          sendResponse(response);
        });
      }

      return true;
    }

    switch (message.msg) {
      case '__PAGE_INFO__':
        sendResponse(getPageInfo(sender));
        break;
      default:
        break;
    }
  });
}

function getPageInfo(sender) {
  const result = {
    faviconURL: ''
  };
  const tab = sender.tab;
  if (tab) {
    result.pageId = tab.id;
    if (tab.favIconUrl) {
      result.faviconURL = tab.favIconUrl;
    }
    if (tab.url) {
      result.pageURL = tab.url;
    }
    if (tab.title) {
      result.pageTitle = tab.title;
    }
  } else {
    result.pageId = 'popup';
    if (sender.url && sender.url.startsWith('chrome')) {
      result.favIconUrl = chrome.runtime.getURL('assets/icon-16.png');
    }
  }
  return result;
}

function _openURL(url, callback) {
  chrome.tabs.query({ url }, tabs => {
    if (tabs.length > 0) {
      chrome.tabs.highlight({ tabs: tabs[0].index }, callback);
    } else {
      chrome.tabs.create({ url }, callback);
    }
  });
}

/***/ }),

/***/ 18:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = checkUpdate;

function checkUpdate() {
  return fetch('https://api.github.com/repos/crimx/crx-saladict/releases/latest').then(r => r.json()).then(data => {
    if (data && data.tag_name) {
      let vGithub = /\d+\.\d+\.\d+/.exec(data.tag_name);
      if (!vGithub) {
        return;
      }
      let gits = vGithub[0].split('.').map(v => Number(v));
      let curs = chrome.runtime.getManifest().version.split('.').map(v => Number(v));
      return {
        info: data,
        isAvailable: gits[0] !== curs[0] ? gits[0] > curs[0] : gits[1] !== curs[1] ? gits[1] > curs[1] : gits[2] > curs[2]
      };
    }
    return { isAvailable: false };
  }).catch(() => {
    console.warn('version check failed');
    return { isAvailable: false };
  });
}

/***/ }),

/***/ 19:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = setContextMenu;

function setContextMenu(config) {
  chrome.contextMenus.removeAll(() => {
    chrome.contextMenus.create({
      id: 'view_as_pdf',
      title: chrome.i18n.getMessage('context_view_as_pdf') || 'View As PDF',
      contexts: ['link', 'browser_action']
    });

    var hasGooglePageTranslate = false;
    var hasYoudaoPageTranslate = false;
    config.contextMenu.selected.forEach(id => {
      var contexts = ['selection'];
      if (id === 'google_page_translate') {
        hasGooglePageTranslate = true;
        contexts = ['all'];
      } else if (id === 'youdao_page_translate') {
        hasYoudaoPageTranslate = true;
        contexts = ['all'];
      }
      chrome.contextMenus.create({
        id,
        title: chrome.i18n.getMessage('context_' + id) || id,
        contexts
      });
    });

    if (!hasGooglePageTranslate) {
      chrome.contextMenus.create({
        id: 'google_page_translate',
        title: chrome.i18n.getMessage('context_google_page_translate') || 'google_page_translate',
        contexts: ['browser_action']
      });
    }
    if (!hasYoudaoPageTranslate) {
      chrome.contextMenus.create({
        id: 'youdao_page_translate',
        title: chrome.i18n.getMessage('context_youdao_page_translate') || 'youdao_page_translate',
        contexts: ['browser_action']
      });
    }

    chrome.contextMenus.create({
      type: 'separator',
      id: Date.now().toString(),
      contexts: ['browser_action']
    });

    chrome.contextMenus.create({
      id: 'search_history',
      title: chrome.i18n.getMessage('history_title') || 'Search History',
      contexts: ['browser_action']
    });

    chrome.contextMenus.create({
      id: 'notebook',
      title: chrome.i18n.getMessage('context_notebook_title') || 'New Word List',
      contexts: ['browser_action']
    });
  });
}

/***/ }),

/***/ 2:
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),

/***/ 3:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = AppConfig;
function AppConfig() {
  return {
    active: true,

    searhHistory: true,

    newWordSound: true,

    mode: 'icon',

    pinMode: 'direct',

    doubleClickDelay: 450,

    tripleCtrl: true,

    tripleCtrlPreload: 'clipboard',

    tripleCtrlAuto: false,

    tripleCtrlLocation: 0,

    baPreload: 'clipboard',

    baAuto: false,

    language: {
      chinese: true,
      english: true
    },

    autopron: {
      cn: {
        dict: '',
        list: ['zdic', 'guoyu']
      },
      en: {
        dict: '',
        list: ['bing', 'dictcn', 'howjsay', 'macmillan', 'eudic', 'urban'],

        accent: 'uk'
      }
    },

    dicts: {
      selected: ['bing', 'urban', 'vocabulary', 'dictcn'],
      all: {
        bing: {
          id: 'bing',
          page: 'https://cn.bing.com/dict/search?q=%s',
          defaultUnfold: true,
          preferredHeight: 240,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            tense: true,
            phsym: true,
            cdef: true,
            related: true,
            sentence: 4
          }
        },
        google: {
          id: 'google',
          page: 'https://translate.google.com/#auto/zh-CN/%s',
          defaultUnfold: true,
          preferredHeight: 110,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        urban: {
          id: 'urban',
          page: 'http://www.urbandictionary.com/define.php?term=%s',
          defaultUnfold: true,
          preferredHeight: 180,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            resultnum: 2
          }
        },
        vocabulary: {
          id: 'vocabulary',
          page: 'https://www.vocabulary.com/dictionary/%s',
          defaultUnfold: true,
          preferredHeight: 180,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        dictcn: {
          id: 'dictcn',
          page: 'http://dict.cn/%s',
          defaultUnfold: true,
          preferredHeight: 300,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            chart: true,
            etym: true
          }
        },
        eudic: {
          id: 'eudic',
          page: 'https://dict.eudic.net/dicts/en/%s',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        etymonline: {
          id: 'etymonline',
          page: 'http://www.etymonline.com/search?q=%s',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            resultnum: 2
          }
        },
        howjsay: {
          id: 'howjsay',
          page: 'http://www.howjsay.com/index.php?word=%s',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            related: true
          }
        },
        guoyu: {
          id: 'guoyu',
          page: 'https://www.moedict.tw/%z',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        liangan: {
          id: 'liangan',
          page: 'https://www.moedict.tw/~%z',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        zdic: {
          id: 'zdic',
          page: 'http://www.zdic.net/search/?c=1&q=%s',
          defaultUnfold: true,
          preferredHeight: 400,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        business: {
          id: 'business',
          page: 'http://www.ldoceonline.com/search/?q=%s',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        cobuild: {
          id: 'cobuild',
          page: 'https://www.collinsdictionary.com/dictionary/%s',
          secret: true,
          defaultUnfold: true,
          preferredHeight: 300,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        macmillan: {
          id: 'macmillan',
          page: 'http://www.macmillandictionary.com/dictionary/british/%s',
          defaultUnfold: true,
          preferredHeight: 265,
          showWhenLang: {
            eng: true,
            chs: true
          }
        },
        wordreference: {
          id: 'wordreference',
          page: 'http://www.wordreference.com/definition/%s',
          defaultUnfold: true,
          preferredHeight: 180,
          showWhenLang: {
            eng: true,
            chs: true
          },
          options: {
            etym: true,
            idiom: true
          }
        }
      }
    },
    contextMenu: {
      selected: ['oxford', 'google_translate', 'merriam_webster', 'cambridge', 'google_search', 'google_page_translate', 'youdao_page_translate'],
      all: {
        google_page_translate: '',
        youdao_page_translate: '',
        google_search: 'https://www.google.com/#newwindow=1&q=%s',
        baidu_search: 'https://www.baidu.com/s?ie=utf-8&wd=%s',
        bing_search: 'https://www.bing.com/search?q=%s',
        google_translate: 'https://translate.google.cn/#auto/zh-CN/%s',
        etymonline: 'http://www.etymonline.com/index.php?search=%s',
        merriam_webster: 'http://www.merriam-webster.com/dictionary/%s',
        oxford: 'http://www.oxforddictionaries.com/us/definition/english/%s',
        cambridge: 'http://dictionary.cambridge.org/spellcheck/english-chinese-simplified/?q=%s',
        youdao: 'http://dict.youdao.com/w/%s',
        dictcn: 'https://dict.eudic.net/dicts/en/%s',
        iciba: 'http://www.iciba.com/%s',
        liangan: 'https://www.moedict.tw/~%s',
        guoyu: 'https://www.moedict.tw/%s',
        longman_business: 'http://www.ldoceonline.com/search/?q=%s',
        bing_dict: 'https://cn.bing.com/dict/?q=%s'
      }
    }
  };
}

/***/ }),

/***/ 32:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_check_update__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_src_app_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__merge_config__ = __webpack_require__(33);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__set_context_menus__ = __webpack_require__(19);






chrome.runtime.onInstalled.addListener(onInstalled);
chrome.runtime.onStartup.addListener(onStartup);
chrome.notifications.onClicked.addListener(clickListener);
chrome.notifications.onButtonClicked.addListener(btnClickListener);

function onInstalled({ reason }) {
  clearHistory();
  mergeRecords('history');
  mergeRecords('notebook');

  let isNew = false;
  __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].sync.get('config', ({ config }) => {
    if (config && config.dicts && config.dicts.all) {
      config = Object(__WEBPACK_IMPORTED_MODULE_3__merge_config__["a" /* default */])(config);
    } else {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.clear();
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].sync.clear();
      config = new __WEBPACK_IMPORTED_MODULE_2_src_app_config__["a" /* default */]();
      isNew = true;
    }

    __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].sync.set({ config, lastCheckUpdate: Date.now() }).then(() => {
      if (isNew) {
        Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["b" /* openURL */])('https://github.com/crimx/crx-saladict/wiki');
      } else if (reason === 'update') {
        showNews();
      }
      Object(__WEBPACK_IMPORTED_MODULE_4__set_context_menus__["a" /* default */])(config);
    });
  });
}

function onStartup() {
  __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get('lastCheckUpdate').then(({ lastCheckUpdate }) => {
    const today = Date.now();
    if (lastCheckUpdate && today - lastCheckUpdate < 30 * 24 * 60 * 60 * 1000) {
      return;
    }
    Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_check_update__["a" /* default */])().then(({ info, isAvailable }) => {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ lastCheckUpdate: today });
      if (isAvailable) {
        chrome.notifications.create('update', {
          requireInteraction: true,
          type: 'basic',
          iconUrl: chrome.runtime.getURL(`assets/icon-128.png`),
          title: '沙拉查词',
          message: `可更新至【${info.tag_name}】`,
          buttons: [{ title: '查看更新' }]
        });
      }
    });
  });
}

function clickListener(id) {
  if (!/^(oninstall|update)$/.test(id)) {
    return;
  }
  Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["b" /* openURL */])('https://github.com/crimx/crx-saladict/wiki');
  chrome.notifications.getAll(notifications => {
    Object.keys(notifications).forEach(id => chrome.notifications.clear(id));
  });
}

function btnClickListener(id) {
  if (!/^(oninstall|update)$/.test(id)) {
    return;
  }
  Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["b" /* openURL */])('https://github.com/crimx/crx-saladict/releases');
  chrome.notifications.getAll(notifications => {
    Object.keys(notifications).forEach(id => chrome.notifications.clear(id));
  });
}

function showNews() {
  chrome.notifications.create('oninstall', {
    requireInteraction: true,
    type: 'basic',
    iconUrl: chrome.runtime.getURL(`assets/icon-128.png`),
    title: '沙拉查词 Saladict【5.28.1】',
    message: `
      1. 增加生词本！
      2. 可配置预加载内容（剪贴板或页面选中词）与自动开始查词，快捷查词可设置出现的位置
      3. 增强系统稳定性
      `.trim().replace(/\s*\n\s*/g, '\n'),
    buttons: [{ title: '查看更新' }]
  });
}

function clearHistory() {
  __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(['folderCatalog', 'collectionCatalog']).then(({ folderCatalog, collectionCatalog }) => {
    return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.remove(['folderCatalog', 'collectionCatalog'].concat(folderCatalog ? folderCatalog.data : [], collectionCatalog || []));
  });
}

function mergeRecords(area) {
  const catName = area + 'Cat';
  __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(response => {
    const catalog = response[catName];
    if (!catalog || catalog.version === 2) {
      return;
    }
    __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catalog.data).then(allSet => {
      catalog.data.forEach((id, i) => {
        const recordSet = allSet[id];
        if (recordSet) {
          recordSet.data.forEach(records => {
            records.data = records.data.map(text => ({ text }));
          });
          __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ [id]: recordSet });
        } else {
          catalog[i] = null;
        }
      });
      catalog.version = 2;
      catalog.data = catalog.data.filter(Boolean);
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ [catName]: catalog });
    });
  });
}

/***/ }),

/***/ 33:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = mergeConfig;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_app_config__ = __webpack_require__(3);


function mergeConfig(config) {
  var base = new __WEBPACK_IMPORTED_MODULE_0_src_app_config__["a" /* default */]();
  if (config.active !== undefined) {
    base.active = Boolean(config.active);
  }
  if (config.searhHistory !== undefined) {
    base.searhHistory = Boolean(config.searhHistory);
  }
  if (config.newWordSound !== undefined) {
    base.newWordSound = Boolean(config.newWordSound);
  }
  if (/^(icon|direct|double|ctrl)$/i.test(config.mode)) {
    base.mode = config.mode.toLowerCase();
  }
  if (/^(direct|double|ctrl)$/i.test(config.pinMode)) {
    base.pinMode = config.pinMode.toLowerCase();
  }
  if (typeof config.doubleClickDelay === 'number' && !isNaN(config.doubleClickDelay)) {
    base.doubleClickDelay = config.doubleClickDelay;
  }
  if (config.tripleCtrl !== undefined) {
    base.tripleCtrl = Boolean(config.tripleCtrl);
  }
  if (typeof config.tripleCtrlPreload === 'string') {
    if (/^clipboard|selection$/.test(config.tripleCtrlPreload)) {
      base.tripleCtrlPreload = config.tripleCtrlPreload;
    } else {
      base.tripleCtrlPreload = '';
    }
  }
  if (config.tripleCtrlAuto !== undefined) {
    base.tripleCtrlAuto = Boolean(config.tripleCtrlAuto);
  }
  if (config.tripleCtrlLocation >= 0 && config.tripleCtrlLocation <= 8) {
    base.tripleCtrlLocation = config.tripleCtrlLocation;
  }

  if (typeof config.baPreload === 'string') {
    if (/^clipboard|selection$/.test(config.baPreload)) {
      base.baPreload = config.baPreload;
    } else {
      base.baPreload = '';
    }
  }
  if (config.baAuto !== undefined) {
    base.baAuto = Boolean(config.baAuto);
  }

  if (config.language) {
    Object.keys(base.language).forEach(k => {
      if (config.language[k] !== undefined) {
        base.language[k] = Boolean(config.language[k]);
      }
    });
  }

  if (config.autopron) {
    if (config.autopron.cn) {
      const id = config.autopron.cn.dict;
      if (base.dicts.all[id]) {
        base.autopron.cn.dict = id;
      }
    }
    if (config.autopron.en) {
      const id = config.autopron.en.dict;
      if (base.dicts.all[id]) {
        base.autopron.en.dict = id;
      }
      if (/^(uk|us)$/i.test(config.autopron.en.accent)) {
        base.autopron.en.accent = config.autopron.en.accent.toLowerCase();
      }
    }
  }

  if (config.dicts) {
    if (Array.isArray(config.dicts.selected)) {
      let selected = config.dicts.selected.filter(id => base.dicts.all[id]);
      if (selected.length > 0) {
        base.dicts.selected = selected;
      }
    }
    if (config.dicts.all) {
      Object.keys(base.dicts.all).forEach(id => {
        let dict = config.dicts.all[id];
        if (!dict) {
          return;
        }
        let baseDict = base.dicts.all[id];
        if (!String(dict.page)) {
          baseDict.page = String(dict.page);
        }
        if (dict.defaultUnfold !== undefined) {
          baseDict.defaultUnfold = Boolean(dict.defaultUnfold);
        }
        if (!isNaN(Number(dict.preferredHeight))) {
          baseDict.preferredHeight = Number(dict.preferredHeight);
        }
        if (dict.showWhenLang) {
          Object.keys(baseDict.showWhenLang).forEach(opt => {
            if (typeof dict.showWhenLang[opt] === 'boolean') {
              baseDict.showWhenLang[opt] = dict.showWhenLang[opt];
            }
          });
        }
        if (dict.options) {
          Object.keys(baseDict.options).forEach(opt => {
            if (typeof dict.options[opt] === 'boolean') {
              baseDict.options[opt] = dict.options[opt];
            } else if (!isNaN(dict.options[opt])) {
              baseDict.options[opt] = Number(dict.options[opt]);
            }
          });
        }
      });
    }
  }

  if (config.contextMenu) {
    if (Array.isArray(config.contextMenu.selected)) {
      if (config.contextMenu.selected.length <= 0) {
        base.contextMenu.selected = [];
      } else {
        let selected = config.contextMenu.selected.filter(id => base.contextMenu.all[id]);
        if (selected.length > 0) {
          base.contextMenu.selected = selected;
        }
      }
    }

    if (!config.contextMenu.all['youdao_page_translate']) {
      base.contextMenu.selected.push('youdao_page_translate');
    }
  }

  return base;
}

/***/ }),

/***/ 4:
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(5);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = "";
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)))

/***/ }),

/***/ 5:
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(6);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),

/***/ 6:
/***/ (function(module, exports) {

/**
 * Helpers.
 */

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var y = d * 365.25;

/**
 * Parse or format the given `val`.
 *
 * Options:
 *
 *  - `long` verbose formatting [false]
 *
 * @param {String|Number} val
 * @param {Object} [options]
 * @throws {Error} throw an error if val is not a non-empty string or a number
 * @return {String|Number}
 * @api public
 */

module.exports = function(val, options) {
  options = options || {};
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse(val);
  } else if (type === 'number' && isNaN(val) === false) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error(
    'val is not a non-empty string or a valid number. val=' +
      JSON.stringify(val)
  );
};

/**
 * Parse the given `str` and return milliseconds.
 *
 * @param {String} str
 * @return {Number}
 * @api private
 */

function parse(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
    str
  );
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}

/**
 * Short format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtShort(ms) {
  if (ms >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (ms >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (ms >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (ms >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}

/**
 * Long format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtLong(ms) {
  return plural(ms, d, 'day') ||
    plural(ms, h, 'hour') ||
    plural(ms, m, 'minute') ||
    plural(ms, s, 'second') ||
    ms + ' ms';
}

/**
 * Pluralization helper.
 */

function plural(ms, n, name) {
  if (ms < n) {
    return;
  }
  if (ms < n * 1.5) {
    return Math.floor(ms / n) + ' ' + name;
  }
  return Math.ceil(ms / n) + ' ' + name + 's';
}


/***/ })

/******/ });
//# sourceMappingURL=initialization.js.map