webpackJsonp([2],{

/***/ 12:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const isContainChinese = function isContainChinese(text) {
  return (/[\u4e00-\u9fa5]/.test(text)
  );
};
/* harmony export (immutable) */ __webpack_exports__["a"] = isContainChinese;


const isContainEnglish = function isContainEnglish(text) {
  return (/[a-zA-Z]/.test(text)
  );
};
/* harmony export (immutable) */ __webpack_exports__["b"] = isContainEnglish;


/* unused harmony default export */ var _unused_webpack_default_export = ({
  isContainChinese,
  isContainEnglish
});

/***/ }),

/***/ 15:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = addRecord;
/* unused harmony export clearRecords */
/* unused harmony export listenRecord */
/* unused harmony export getAllWords */
/* unused harmony export removeWord */
/* unused harmony export saveWord */
/* unused harmony export getRecordSet */
/* unused harmony export getWordCount */
/* harmony export (immutable) */ __webpack_exports__["b"] = init;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__ = __webpack_require__(1);




const catVersion = 2;

function addRecord(area, word) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => getLatestSet(res[catName])).then(getTodayItem).then(res => appendAndSave(res, word, catName));
}

function clearRecords(area) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => {
    const catalog = res[catName];
    if (catalog) {
      return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.remove(catalog.data.concat(catName));
    }
    return Promise.resolve();
  });
}

function listenRecord(area, cb) {
  if (typeof cb === 'function') {
    __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.listen(area + 'Cat', cb);
  }
}

function getAllWords(area) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => {
    const catalog = res[catName];
    if (!catalog) {
      return Promise.resolve([]);
    }
    const setIds = catalog.data;
    return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(setIds).then(allSets => {
      var result = [];
      for (let i = 0; i < setIds.length; i++) {
        const records = allSets[setIds[i]].data;
        for (let j = 0; j < records.length; j++) {
          result = result.concat(records[j].data);
        }
      }
      return result;
    });
  });
}

function removeWord(area, setId, recordDate, text) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(setId).then(res => {
    const recordSet = res[setId];
    if (!recordSet) {
      return Promise.reject('no set to delete word');
    }

    const iRecord = recordSet.data.findIndex(r => r.date === recordDate);
    if (iRecord === -1) {
      return Promise.reject('no record to delete word');
    }
    const record = recordSet.data[iRecord];

    const iWord = record.data.findIndex(word => word.text === text);
    if (iWord === -1) {
      return Promise.reject('no word to delete');
    }

    record.data.splice(iWord, 1);
    recordSet.wordCount -= 1;
    if (record.data.length <= 0) {
      recordSet.data.splice(iRecord, 1);
    }
    return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => {
      const catalog = res[catName];
      catalog.wordCount -= 1;
      catalog.timestamp = Date.now();
      if (recordSet.data.length <= 0) {
        const iSet = catalog.data.indexOf(setId);
        if (iSet !== -1) {
          catalog.data.splice(iSet, 1);
        }
        return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.remove(setId).then(() => {
          __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ [catName]: catalog });
        });
      }
      return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({
        [catName]: catalog,
        [setId]: recordSet
      });
    });
  });
}

function saveWord(area, { setId, iRecord, iWord, word }) {
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(setId).then(res => {
    const recordSet = res[setId];
    if (!recordSet) {
      return Promise.reject('no set to save word');
    }

    if (iRecord >= recordSet.data.length) {
      return Promise.reject('no record to save word');
    }
    const record = recordSet.data[iRecord];

    if (iWord >= record.data.length) {
      return Promise.reject('no word to save');
    }

    record.data[iWord] = word;

    return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ [setId]: recordSet });
  });
}

function getRecordSet(area, index) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => {
    const catalog = res[catName];
    if (catalog && catalog.data[index]) {
      const id = catalog.data[index];
      return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(id).then(res => ({
        recordSet: res[id],
        pageCount: catalog.data.length
      }));
    }
    return {};
  });
}

function getWordCount(area) {
  const catName = area + 'Cat';
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catName).then(res => {
    const catalog = res[catName];
    return catalog ? catalog.wordCount : 0;
  });
}

function getLatestSet(catalog) {
  if (!catalog || catalog.data.length <= 0) {
    const latestSet = {
      id: Date.now().toString(),
      data: [],
      wordCount: 0
    };
    catalog = {
      version: catVersion,
      data: [latestSet.id],
      wordCount: 0
    };
    return { catalog, latestSet };
  }

  const id = catalog.data[0];
  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(id).then(response => {
    let latestSet = response[id];
    if (latestSet) {
      return { catalog, latestSet };
    } else {
      latestSet = {
        id: Date.now().toString(),
        data: [],
        wordCount: 0
      };

      return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.get(catalog.data).then(allSets => {
        catalog.data = catalog.data.filter(id => allSets[id]);
        catalog.wordCount = catalog.data.reduce((sum, id) => allSets[id].wordCount + sum, 0);
        catalog.data.unshift(latestSet.id);
        return { catalog, latestSet };
      });
    }
  });
}

function getTodayItem({ catalog, latestSet }) {
  const today = getToday();
  if (latestSet.data.length > 0 && latestSet.data[0].date === today) {
    return { catalog, latestSet, todayItem: latestSet.data[0] };
  }

  const todayItem = {
    date: today,
    data: []
  };

  if (latestSet.wordCount >= 500) {
    latestSet = {
      id: Date.now().toString(),
      data: [],
      wordCount: 0
    };
    catalog.data.unshift(latestSet.id);
    if (catalog.data.length > 50) {
      const oldestSet = catalog.data.pop();
      catalog.wordCount -= oldestSet.wordCount;
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.remove(oldestSet.id);
    }
  }

  latestSet.data.unshift(todayItem);
  return { catalog, latestSet, todayItem };
}

function appendAndSave({ catalog, latestSet, todayItem }, word, catName) {
  const index = todayItem.data.findIndex(w => w.text === word.text);
  if (index === -1 || todayItem.data[index].sentence !== word.sentence) {
    latestSet.wordCount += 1;
    catalog.wordCount += 1;
  } else {
    todayItem.data.splice(index, 1);
  }
  todayItem.data.unshift(word);
  catalog.timestamp = Date.now();

  return __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({
    [catName]: catalog,
    [latestSet.id]: latestSet
  });
}

function getToday() {
  const d = new Date();
  const month = d.getMonth() + 1;
  const date = d.getDate();
  const year = d.getFullYear();
  return (month < 10 ? '0' : '') + month + (date < 10 ? '0' : '') + date + year;
}

function init(area) {
  return {
    addRecord: (...args) => addRecord(area, ...args),
    clearRecords: (...args) => clearRecords(area, ...args),
    listenRecord: (...args) => listenRecord(area, ...args),
    getRecordSet: (...args) => getRecordSet(area, ...args),
    getAllWords: (...args) => getAllWords(area, ...args),
    saveWord: (...args) => saveWord(area, ...args),
    removeWord: (...args) => removeWord(area, ...args),
    getWordCount: (...args) => getWordCount(area, ...args)
  };
}

/***/ }),

/***/ 16:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

const promiseReflect = function promiseReflect(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  return Promise.all(iterable.map(p => Promise.resolve(p).catch(() => null)));
};
/* harmony export (immutable) */ __webpack_exports__["a"] = promiseReflect;


const promiseAny = function promiseAny(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  var rejectCount = 0;
  var reasons = [];
  var promises = iterable.map((p, i) => Promise.resolve(p).catch(e => {
    rejectCount++;
    reasons[i] = e;
    return null;
  }));

  return Promise.all(promises).then(resolutions => {
    if (rejectCount === resolutions.length) {
      return Promise.reject(reasons);
    }
    return resolutions;
  });
};
/* unused harmony export promiseAny */


const promiseFirst = function promiseFirst(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  var rejectCount = 0;
  var reasons = [];
  return new Promise((resolve, reject) => iterable.forEach((p, i) => {
    Promise.resolve(p).then(resolve).catch(e => {
      reasons[i] = e;
      if (++rejectCount === iterable.length) {
        reject(reasons);
      }
    });
  }));
};
/* unused harmony export promiseFirst */


const promiseTimer = function promiseTimer(delay = 0) {
  return new Promise(resolve => {
    var id = setTimeout(() => resolve(id), Number(delay) || 0);
  });
};
/* harmony export (immutable) */ __webpack_exports__["b"] = promiseTimer;


const promiseTimeout = function promiseTimeout(pr, delay = 0) {
  delay = Number(delay);
  return new Promise((resolve, reject) => {
    Promise.resolve(pr).then(resolve, reject);
    if (delay > 0) {
      promiseTimer(delay).then(() => {
        reject(new Error(`timeout ${delay}ms`));
      });
    }
  });
};
/* unused harmony export promiseTimeout */


/* unused harmony default export */ var _unused_webpack_default_export = ({
  reflect: promiseReflect,
  any: promiseAny,
  first: promiseFirst,
  timer: promiseTimer,
  timeout: promiseTimeout
});

/***/ }),

/***/ 64:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_vue__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__Panel__ = __webpack_require__(65);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_src_app_config__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_src_helpers_chrome_api__ = __webpack_require__(1);





__WEBPACK_IMPORTED_MODULE_0_vue__["a" /* default */].config.productionTip = false;
__WEBPACK_IMPORTED_MODULE_0_vue__["a" /* default */].config.devtools = false;

__WEBPACK_IMPORTED_MODULE_3_src_helpers_chrome_api__["c" /* storage */].sync.get('config').then(({ config = new __WEBPACK_IMPORTED_MODULE_2_src_app_config__["a" /* default */]() }) => {
  Object.keys(config.dicts.all).forEach(id => {
    __WEBPACK_IMPORTED_MODULE_0_vue__["a" /* default */].component(id, () => Promise.resolve(__webpack_require__(26)("./" + id + '/view.vue')));
  });

  const vm = new __WEBPACK_IMPORTED_MODULE_0_vue__["a" /* default */]({
    el: '#app',
    data: { config },
    render(createElement) {
      return createElement(__WEBPACK_IMPORTED_MODULE_1__Panel__["a" /* default */], {
        props: {
          config: this.config,
          i18n: key => chrome.i18n.getMessage(key)
        }
      });
    }
  });

  __WEBPACK_IMPORTED_MODULE_3_src_helpers_chrome_api__["c" /* storage */].sync.listen('config', changes => {
    let config = changes.config.newValue;
    if (config) {
      vm.config = config;
    }
  });
});

/***/ }),

/***/ 65:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_bustCache_Panel_vue__ = __webpack_require__(69);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_16ba6993_hasScoped_true_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_bustCache_Panel_vue__ = __webpack_require__(70);
var disposed = false
function injectStyle (ssrContext) {
  if (disposed) return
  __webpack_require__(66)
  __webpack_require__(67)
  __webpack_require__(68)
}
var normalizeComponent = __webpack_require__(0)
/* script */

/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-16ba6993"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null
var Component = normalizeComponent(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_bustCache_Panel_vue__["a" /* default */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_16ba6993_hasScoped_true_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_bustCache_Panel_vue__["a" /* default */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src\\content\\panel\\Panel.vue"
if (Component.esModule && Object.keys(Component.esModule).some(function (key) {  return key !== "default" && key.substr(0, 2) !== "__"})) {  console.error("named exports are not supported in *.vue files.")}

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-16ba6993", Component.options)
  } else {
    hotAPI.reload("data-v-16ba6993", Component.options)
' + '  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["a"] = (Component.exports);


/***/ }),

/***/ 66:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 67:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 68:
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),

/***/ 69:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_lang_check__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_src_helpers_record_manager__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_src_helpers_promise_more__ = __webpack_require__(16);







const isSmoothScrollSupported = 'scrollBehavior' in document.documentElement.style;

/* harmony default export */ __webpack_exports__["a"] = ({
  name: 'dictionary-panel',
  props: ['config', 'i18n'],
  data() {
    return {
      dicts: Object.keys(this.config.dicts.all).reduce((dicts, id) => {
        dicts[id] = {
          result: null,
          height: 0,
          offsetHeight: 0,
          favicon: chrome.runtime.getURL(`assets/dicts/${id}.png`),
          name: chrome.i18n.getMessage('dict_' + id) || id,
          isShow: false,
          isUnfolded: false,
          isSearching: false
        };
        return dicts;
      }, {}),

      text: '',
      selectionInfo: {},

      isShowNewWordCard: false,
      noSearchHistory: false,
      isDragging: false,
      isPinned: false
    };
  },
  methods: {
    seachText(activeDicts) {
      const isOneActiveDict = !Array.isArray(activeDicts);
      if (isOneActiveDict) {
        activeDicts = [activeDicts];
      }
      const text = this.text.trim();
      this.text = text;
      const dicts = this.dicts;

      this.checkSelectionLang();

      activeDicts.forEach(id => {
        const dict = dicts[id];
        if (!dict.isShow) {
          return;
        }

        this.foldDict(id);
        dict.isSearching = true;
        dict.result = null;

        Promise.race([Object(__WEBPACK_IMPORTED_MODULE_3_src_helpers_promise_more__["b" /* promiseTimer */])(10000), __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'FETCH_DICT_RESULT', text, dict: id })]).then(response => {
          dict.isSearching = false;

          if (!response || response.error) {
            dict.isUnfolded = true;
            return;
          }

          dict.result = response.result;

          this.$nextTick(() => {
            let i = this.config.dicts.selected.indexOf(id);
            dict.offsetHeight = this.$refs.dict[i].firstChild.offsetHeight;
            this.unfoldDict(id, i);
          });
        });
      });

      if (!this.noSearchHistory && this.config.searhHistory) {
        Object(__WEBPACK_IMPORTED_MODULE_2_src_helpers_record_manager__["a" /* addRecord */])('history', this.selectionInfo);
      }

      if (!isOneActiveDict) {
        if (isSmoothScrollSupported) {
          this.$refs.scrollContainer.scrollTo({ top: 0, left: 0, behavior: 'smooth' });
        } else {
          this.$refs.scrollContainer.scrollTo(0, 0);
        }
      }
    },
    checkSelectionLang() {
      const allDicts = this.config.dicts.all;
      const isEng = Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_lang_check__["b" /* isContainEnglish */])(this.text);
      this.config.dicts.selected.forEach(id => {
        this.dicts[id].isShow = allDicts[id].showWhenLang.eng && isEng || allDicts[id].showWhenLang.chs && !isEng;
      });
    },
    updateDragAreaCoord() {
      const $da = this.$refs.dragarea;
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].self.send({ msg: 'DRAG_AREA', left: $da.offsetLeft, width: $da.offsetWidth });
    },
    closePanel() {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].self.send({ msg: 'CLOSE_PANEL' });
    },
    pinPanel() {
      this.isPinned = !this.isPinned;
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].self.send({ msg: 'PIN_PANEL', flag: this.isPinned });
    },
    openOptionsPage() {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'OPEN_URL', url: chrome.runtime.getURL('options.html') });
    },
    openShareimgPage() {
      const dicts = this.config.dicts.selected.map(id => {
        const result = this.dicts[id].result;
        if (result && this.dicts[id].isUnfolded) {
          return { id, result };
        }
        return null;
      }).filter(Boolean);

      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].local.set({ paneldata: { text: this.text, dicts } }, () => {
        __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'OPEN_URL', url: chrome.runtime.getURL('shareimg.html') });
      });
    },
    openHistoryPage() {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'OPEN_URL', url: chrome.runtime.getURL('history.html') });
    },
    openNoteBook() {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'OPEN_URL', url: chrome.runtime.getURL('notebook.html') });
    },
    addNewWord() {
      if (!this.text) {
        return;
      }
      if (this.config.newWordSound) {
        new Audio(chrome.runtime.getURL('assets/notification.mp3')).play();
      }
      this.isShowNewWordCard = true;
      Object(__WEBPACK_IMPORTED_MODULE_2_src_helpers_record_manager__["a" /* addRecord */])('notebook', this.selectionInfo);
    },
    unfoldDict(id) {
      let dict = this.dicts[id];
      dict.isUnfolded = true;

      if (!dict.result) {
        this.seachText(id);
        return;
      }

      const preferredHeight = this.config.dicts.all[id].preferredHeight;
      dict.height = dict.offsetHeight < preferredHeight ? dict.offsetHeight : preferredHeight;
    },
    foldDict(id) {
      const dict = this.dicts[id];
      dict.height = 0;
      dict.isUnfolded = false;
    },
    handleUnfold(id) {
      const dict = this.dicts[id];
      dict.isUnfolded ? this.foldDict(id) : this.unfoldDict(id);
    },
    handleDictPage(id) {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({
        msg: 'OPEN_URL',
        escape: true,
        url: this.config.dicts.all[id].page
      });
    },
    handleDictsPanelClick(evt) {
      for (let target = evt.target; target !== evt.currentTarget; target = target.parentNode) {
        if (target.href) {
          const text = target.innerText.trim();
          if (/\s/.test(text)) {
            chrome.runtime.sendMessage({ msg: 'OPEN_URL', url: target.href });
          } else {
            this.handleSearchText({ text });
          }
          evt.preventDefault();
          return;
        }
      }
    },
    handleDictsPanelDbClick(evt) {
      const text = window.getSelection().toString().trim();
      if (text) {
        this.handleSearchText({ text });
      }
    },
    handleSearchText(data) {
      data = data || {};
      if (data.text) {
        this.text = data.text;
      }
      this.selectionInfo = data.selectionInfo || {
        text: this.text,
        sentence: '',
        title: chrome.i18n.getMessage('from_saladict_panel'),
        url: '#',
        faviconURL: chrome.runtime.getURL('assets/icon-16.png'),
        trans: '',
        note: ''
      };
      this.config.dicts.selected.forEach(id => {
        this.foldDict(id);
        this.dicts[id].result = null;
      });
      this.seachText(this.defaultUnfoldList);
    }
  },
  created() {
    __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].self.on('SEARCH_TEXT', (data, sender, sendResponse) => {
      this.handleSearchText({ text: data.selectionInfo.text, selectionInfo: data.selectionInfo });
      sendResponse();
    });

    __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].self.send({ msg: 'PANEL_READY' }, response => {
      if (!response) {
        return;
      }
      if (response.preload === 'clipboard') {
        this.$refs.searchbox.focus();
        document.execCommand('paste');
        if (response.autoSearch) {
          this.handleSearchText({ text: this.$refs.searchbox.value });
        } else {
          this.$refs.searchbox.select();
        }
      } else if (response.preload === 'selection') {
        __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send({ msg: 'PRELOAD_SELECTION' }, selectionInfo => {
          this.selectionInfo = selectionInfo;
          const text = selectionInfo.text;
          if (!text) {
            return;
          }
          if (response.autoSearch) {
            this.handleSearchText({ text });
          } else {
            this.text = text;
            this.$nextTick(() => {
              this.$refs.searchbox.focus();
              this.$refs.searchbox.select();
            });
          }
        });
      } else {
        this.$refs.searchbox.focus();
      }

      if (response.noSearchHistory) {
        this.noSearchHistory = true;
      }
    });
  },
  mounted() {
    setTimeout(() => this.updateDragAreaCoord(), 1000);
  },
  computed: {
    defaultUnfoldList() {
      const allDicts = this.config.dicts.all;
      return this.config.dicts.selected.filter(id => allDicts[id].defaultUnfold);
    }
  }
});

/***/ }),

/***/ 70:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    {
      staticClass: "panel-container",
      class: { "no-user-select": _vm.isDragging }
    },
    [
      _c("header", { staticClass: "panel-header" }, [
        _c("input", {
          directives: [
            {
              name: "model",
              rawName: "v-model.trim",
              value: _vm.text,
              expression: "text",
              modifiers: { trim: true }
            }
          ],
          ref: "searchbox",
          staticClass: "search-input",
          attrs: { type: "text" },
          domProps: { value: _vm.text },
          on: {
            transitionend: _vm.updateDragAreaCoord,
            keyup: function($event) {
              if (
                !("button" in $event) &&
                _vm._k($event.keyCode, "enter", 13, $event.key)
              ) {
                return null
              }
              _vm.handleSearchText()
            },
            input: function($event) {
              if ($event.target.composing) {
                return
              }
              _vm.text = $event.target.value.trim()
            },
            blur: function($event) {
              _vm.$forceUpdate()
            }
          }
        }),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-search",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 52.966 52.966"
            },
            on: {
              click: function($event) {
                _vm.handleSearchText()
              }
            }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M51.704 51.273L36.844 35.82c3.79-3.8 6.14-9.04 6.14-14.82 0-11.58-9.42-21-21-21s-21 9.42-21 21 9.42 21 21 21c5.082 0 9.747-1.817 13.383-4.832l14.895 15.49c.196.206.458.308.72.308.25 0 .5-.093.694-.28.398-.382.41-1.015.028-1.413zM21.984 40c-10.478 0-19-8.523-19-19s8.522-19 19-19 19 8.523 19 19-8.525 19-19 19z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c("div", { ref: "dragarea", staticClass: "dragarea" }),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-options",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 612 612"
            },
            on: { click: _vm.openOptionsPage }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M0 97.92v24.48h612V97.92H0zm0 220.32h612v-24.48H0v24.48zm0 195.84h612V489.6H0v24.48z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-notebook",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 512 512"
            },
            on: {
              click: function($event) {
                if (
                  !("button" in $event) &&
                  _vm._k($event.keyCode, "left", 37, $event.key)
                ) {
                  return null
                }
                if ("button" in $event && $event.button !== 0) {
                  return null
                }
                _vm.addNewWord($event)
              },
              contextmenu: function($event) {
                $event.preventDefault()
                _vm.openNoteBook($event)
              }
            }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M448 0H85.333c-17.643 0-32 14.357-32 32v53.333H42.667C36.78 85.333 32 90.113 32 96s4.78 10.667 10.667 10.667h10.667V192H42.667C36.78 192 32 196.78 32 202.667s4.78 10.667 10.667 10.667h10.667v85.333H42.667c-5.888 0-10.667 4.78-10.667 10.667S36.78 320 42.667 320h10.667v85.333H42.667C36.78 405.333 32 410.113 32 416c0 5.888 4.78 10.667 10.667 10.667h10.667V480c0 17.643 14.357 32 32 32H448c17.643 0 32-14.357 32-32V32c0-17.643-14.357-32-32-32zm10.667 480c0 5.888-4.8 10.667-10.667 10.667H85.333c-5.867 0-10.667-4.78-10.667-10.667v-53.333h23.296C102.38 439.06 114.112 448 128 448c17.643 0 32-14.357 32-32s-14.357-32-32-32c-13.888 0-25.62 8.94-30.037 21.333H74.667V320h23.296c4.416 12.395 16.15 21.333 30.037 21.333 17.643 0 32-14.357 32-32s-14.357-32-32-32c-13.888 0-25.62 8.94-30.037 21.333H74.667v-85.333h23.296c4.416 12.395 16.15 21.333 30.037 21.333 17.643 0 32-14.357 32-32s-14.357-32-32-32c-13.888 0-25.62 8.94-30.037 21.333H74.667v-85.335h23.296C102.38 119.06 114.113 128 128 128c17.643 0 32-14.357 32-32s-14.357-32-32-32c-13.888 0-25.62 8.94-30.037 21.333H74.667V32c0-5.888 4.8-10.667 10.667-10.667H448c5.867 0 10.667 4.78 10.667 10.667v448zm-341.334-64c0-5.888 4.8-10.667 10.667-10.667s10.667 4.78 10.667 10.667c0 5.888-4.8 10.667-10.667 10.667s-10.667-4.78-10.667-10.667zm0-106.667c0-5.888 4.8-10.667 10.667-10.667s10.667 4.78 10.667 10.667S133.867 320 128 320s-10.667-4.78-10.667-10.667zm0-106.666c0-5.888 4.8-10.667 10.667-10.667s10.667 4.78 10.667 10.667-4.8 10.667-10.667 10.667-10.667-4.78-10.667-10.667zm0-106.667c0-5.888 4.8-10.667 10.667-10.667s10.667 4.78 10.667 10.667-4.8 10.667-10.667 10.667-10.667-4.78-10.667-10.667z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-history",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 64 64"
            },
            on: { click: _vm.openHistoryPage }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M34.688 3.315c-15.887 0-28.812 12.924-28.81 28.73-.012.25-.157 4.434 1.034 8.94l-3.88-2.262c-.965-.56-2.193-.235-2.76.727-.557.96-.233 2.195.728 2.755l9.095 5.302c.02.01.038.013.056.022.1.05.2.09.31.12.07.02.14.05.21.07.09.02.176.02.265.03.06.003.124.022.186.022.036 0 .07-.01.105-.015.034 0 .063.007.097.004.05-.003.097-.024.146-.032.097-.017.19-.038.28-.068.08-.028.157-.06.23-.095.086-.04.165-.085.24-.137.074-.046.14-.096.206-.15.07-.06.135-.125.198-.195.06-.067.11-.135.16-.207.026-.04.062-.07.086-.11.017-.03.017-.067.032-.1.03-.053.07-.1.096-.16l3.62-8.96c.417-1.03-.08-2.205-1.112-2.622-1.033-.413-2.207.083-2.624 1.115l-1.86 4.6c-1.24-4.145-1.1-8.406-1.093-8.523C9.92 18.455 21.04 7.34 34.7 7.34c13.663 0 24.78 11.116 24.78 24.78S48.357 56.9 34.694 56.9c-1.114 0-2.016.902-2.016 2.015s.9 2.02 2.012 2.02c15.89 0 28.81-12.925 28.81-28.81 0-15.89-12.923-28.814-28.81-28.814z"
              }
            }),
            _vm._v(" "),
            _c("path", {
              attrs: {
                d:
                  "M33.916 36.002c.203.084.417.114.634.13.045.002.09.026.134.026.236 0 .465-.054.684-.134.06-.022.118-.054.177-.083.167-.08.32-.18.463-.3.03-.023.072-.033.103-.07L48.7 22.98c.788-.79.788-2.064 0-2.852-.787-.788-2.062-.788-2.85 0l-11.633 11.63-10.44-4.37c-1.032-.432-2.208.052-2.64 1.08-.43 1.027.056 2.208 1.08 2.638L33.907 36c.002 0 .006 0 .01.002z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-share",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 58.999 58.999"
            },
            on: { click: _vm.openShareimgPage }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M19.48 12.02c.255 0 .51-.1.706-.294L28.5 3.413V39c0 .552.446 1 1 1s1-.448 1-1V3.412l8.27 8.272c.392.39 1.024.39 1.415 0s.39-1.023 0-1.414L30.207.294C30.115.2 30.004.127 29.88.076c-.244-.1-.52-.1-.764 0-.123.05-.234.125-.326.217l-10.018 10.02c-.39.39-.39 1.022 0 1.413.195.196.45.293.707.293z"
              }
            }),
            _vm._v(" "),
            _c("path", {
              attrs: {
                d:
                  "M36.5 16c-.554 0-1 .446-1 1s.446 1 1 1h13v39h-40V18h13c.552 0 1-.448 1-1s-.448-1-1-1h-15v43h44V16h-15z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-pin",
            class: { "icon-pin--pinned": _vm.isPinned },
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 53.011 53.011"
            },
            on: { click: _vm.pinPanel }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M52.963 21.297c-.068-.33-.297-.603-.61-.727-8.573-3.416-16.172-.665-18.36.288L19.113 8.2C19.634 3.632 17.17.508 17.06.372c-.18-.22-.442-.356-.725-.372-.282-.006-.56.09-.76.292L.32 15.546c-.202.2-.308.48-.29.765.015.285.152.55.375.727 2.775 2.202 6.35 2.167 7.726 2.055l12.722 14.953c-.868 2.23-3.52 10.27-.307 18.337.124.313.397.54.727.61.067.013.135.02.202.02.263 0 .518-.104.707-.293l14.57-14.57 13.57 13.57c.196.194.452.292.708.292s.512-.098.707-.293c.39-.392.39-1.024 0-1.415l-13.57-13.57 14.527-14.528c.237-.238.34-.58.27-.91zm-17.65 15.458L21.89 50.18c-2.437-8.005.993-15.827 1.03-15.91.158-.352.1-.764-.15-1.058L9.31 17.39c-.19-.225-.473-.352-.764-.352-.05 0-.103.004-.154.013-.036.007-3.173.473-5.794-.954l13.5-13.5c.604 1.156 1.39 3.26.964 5.848-.058.346.07.697.338.924l15.785 13.43c.31.262.748.31 1.105.128.077-.04 7.378-3.695 15.87-1.017L35.313 36.754z"
              }
            })
          ]
        ),
        _vm._v(" "),
        _c(
          "svg",
          {
            staticClass: "icon-close",
            attrs: {
              xmlns: "http://www.w3.org/2000/svg",
              viewBox: "0 0 31.112 31.112"
            },
            on: { click: _vm.closePanel }
          },
          [
            _c("path", {
              attrs: {
                d:
                  "M31.112 1.414L29.698 0 15.556 14.142 1.414 0 0 1.414l14.142 14.142L0 29.698l1.414 1.414L15.556 16.97l14.142 14.142 1.414-1.414L16.97 15.556"
              }
            })
          ]
        )
      ]),
      _vm._v(" "),
      _c(
        "div",
        {
          ref: "scrollContainer",
          staticClass: "dicts",
          on: {
            click: _vm.handleDictsPanelClick,
            dblclick: _vm.handleDictsPanelDbClick
          }
        },
        _vm._l(_vm.config.dicts.selected, function(id) {
          return _c(
            "section",
            {
              directives: [
                {
                  name: "show",
                  rawName: "v-show",
                  value: _vm.dicts[id].isShow,
                  expression: "dicts[id].isShow"
                }
              ],
              staticClass: "dict-item"
            },
            [
              _c(
                "header",
                {
                  staticClass: "dict-item-header",
                  on: {
                    click: function($event) {
                      _vm.handleUnfold(id)
                    }
                  }
                },
                [
                  _c("img", {
                    staticClass: "dict-item-logo",
                    attrs: { src: _vm.dicts[id].favicon },
                    on: {
                      click: function($event) {
                        $event.stopPropagation()
                        _vm.handleDictPage(id)
                      }
                    }
                  }),
                  _vm._v(" "),
                  _c(
                    "h1",
                    {
                      staticClass: "dict-item-name",
                      on: {
                        click: function($event) {
                          $event.stopPropagation()
                          _vm.handleDictPage(id)
                        }
                      }
                    },
                    [_vm._v(_vm._s(_vm.dicts[id].name))]
                  ),
                  _vm._v(" "),
                  _c(
                    "div",
                    { staticClass: "loader-wrap" },
                    [
                      _c("transition", { attrs: { name: "fade" } }, [
                        _vm.dicts[id].isSearching
                          ? _c(
                              "svg",
                              {
                                staticClass: "loader",
                                attrs: {
                                  viewBox: "0 0 120 10",
                                  xmlns: "http://www.w3.org/2000/svg",
                                  width: "120",
                                  height: "10"
                                }
                              },
                              [
                                _c("circle", {
                                  staticClass: "loader-item",
                                  attrs: { cx: "5", cy: "5", r: "5" }
                                }),
                                _vm._v(" "),
                                _c("circle", {
                                  staticClass: "loader-item",
                                  staticStyle: { "animation-delay": "-0.4s" },
                                  attrs: { cx: "5", cy: "5", r: "5" }
                                }),
                                _vm._v(" "),
                                _c("circle", {
                                  staticClass: "loader-item",
                                  staticStyle: { "animation-delay": "-0.8s" },
                                  attrs: { cx: "5", cy: "5", r: "5" }
                                }),
                                _vm._v(" "),
                                _c("circle", {
                                  staticClass: "loader-item",
                                  staticStyle: { "animation-delay": "-1.2s" },
                                  attrs: { cx: "5", cy: "5", r: "5" }
                                }),
                                _vm._v(" "),
                                _c("circle", {
                                  staticClass: "loader-item",
                                  staticStyle: { "animation-delay": "-1.6s" },
                                  attrs: { cx: "5", cy: "5", r: "5" }
                                })
                              ]
                            )
                          : _vm._e()
                      ])
                    ],
                    1
                  ),
                  _vm._v(" "),
                  _c(
                    "svg",
                    {
                      staticClass: "fold-arrow",
                      class: { "fold-arrow--unfold": _vm.dicts[id].isUnfolded },
                      attrs: {
                        xmlns: "http://www.w3.org/2000/svg",
                        viewBox: "0 0 59.414 59.414"
                      },
                      on: {
                        click: function($event) {
                          $event.stopPropagation()
                          _vm.handleUnfold(id)
                        }
                      }
                    },
                    [
                      _c("path", {
                        attrs: {
                          d:
                            "M43.854 59.414L14.146 29.707 43.854 0l1.414 1.414-28.293 28.293L45.268 58"
                        }
                      })
                    ]
                  )
                ]
              ),
              _vm._v(" "),
              _c(
                "div",
                {
                  ref: "dict",
                  refInFor: true,
                  staticClass: "dict-item-body",
                  class: { "dict-item-body--show": _vm.dicts[id].height > 0 },
                  style: { height: _vm.dicts[id].height + "px" }
                },
                [
                  _c(id, {
                    tag: "component",
                    attrs: { result: _vm.dicts[id].result },
                    on: { search: _vm.handleSearchText }
                  }),
                  _vm._v(" "),
                  _c("transition", { attrs: { name: "fade" } }, [
                    _vm.dicts[id].height > 0 &&
                    _vm.dicts[id].height !== _vm.dicts[id].offsetHeight
                      ? _c(
                          "div",
                          {
                            staticClass: "semi-unfold-mask",
                            on: {
                              click: function($event) {
                                _vm.dicts[id].height =
                                  _vm.dicts[id].offsetHeight
                              }
                            }
                          },
                          [
                            _c(
                              "svg",
                              {
                                staticClass: "semi-unfold-mask-arrow",
                                attrs: {
                                  xmlns: "http://www.w3.org/2000/svg",
                                  viewBox: "0 0 59.414 59.414"
                                }
                              },
                              [
                                _c("path", {
                                  attrs: {
                                    d:
                                      "M58 14.146L29.707 42.44 1.414 14.145 0 15.56 29.707 45.27 59.414 15.56"
                                  }
                                })
                              ]
                            )
                          ]
                        )
                      : _vm._e()
                  ])
                ],
                1
              )
            ]
          )
        })
      ),
      _vm._v(" "),
      _vm.isShowNewWordCard
        ? _c(
            "transition",
            {
              attrs: { appear: "", name: "popup" },
              on: {
                "after-enter": function($event) {
                  _vm.isShowNewWordCard = false
                }
              }
            },
            [
              _c("div", { staticClass: "new-word-card" }, [
                _c("h1", [_vm._v(_vm._s(_vm.text))])
              ])
            ]
          )
        : _vm._e()
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true
var esExports = { render: render, staticRenderFns: staticRenderFns }
/* harmony default export */ __webpack_exports__["a"] = (esExports);
if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-16ba6993", esExports)
  }
}

/***/ })

},[64]);
//# sourceMappingURL=panel.js.map