/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 35);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */,
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = openURL;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_debug__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_debug___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_debug__);




var debugMsg = __WEBPACK_IMPORTED_MODULE_0_debug___default()('message');

const messageListeners = new Map();

const storageListeners = new Map();

const storage = {
  sync: {
    clear: storageClear('sync'),
    remove: storageRemove('sync'),
    get: storageGet('sync'),
    set: storageSet('sync'),
    listen: storageListen('sync'),
    addListener: storageListen('sync'),
    on: storageListen('sync')
  },
  local: {
    clear: storageClear('local'),
    remove: storageRemove('local'),
    get: storageGet('local'),
    set: storageSet('local'),
    listen: storageListen('local'),
    addListener: storageListen('local'),
    on: storageListen('local')
  },
  listen: storageListen(),
  addListener: storageListen(),
  on: storageListen(),

  off: storageStopListen,
  removeListener: storageStopListen
};
/* harmony export (immutable) */ __webpack_exports__["c"] = storage;


const message = {
  send: messageSend,
  fire: messageSend,
  emit: messageSend,

  listen: messageListen,
  addListener: messageListen,
  on: messageListen,

  off: messageStopListen,
  removeListener: messageStopListen,

  server: initServer,

  self: {
    send: messageSendSelf,
    fire: messageSendSelf,
    emit: messageSendSelf,

    listen: messageListenSelf,
    addListener: messageListenSelf,
    on: messageListenSelf,

    off: messageStopListen,
    removeListener: messageStopListen
  }
};
/* harmony export (immutable) */ __webpack_exports__["a"] = message;


function openURL(url, callback) {
  if (typeof url !== 'string') {
    throw new TypeError('arg 1 should be a string');
  }
  if (callback) {
    return _openURL(url, callback);
  } else {
    return new Promise(resolve => _openURL(url, resolve));
  }
}

/* unused harmony default export */ var _unused_webpack_default_export = ({
  openURL,
  storage,
  message
});

function storageGet(storageArea) {
  return function get(keys, cb) {
    if (typeof keys === 'function') {
      cb = keys;
      return chrome.storage[storageArea].get(cb);
    } else if (typeof cb === 'function') {
      return chrome.storage[storageArea].get(keys, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].get(keys, data => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve(data);
          }
        });
      });
    }
  };
}

function storageSet(storageArea) {
  return function set(items, cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].set(items, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].set(items, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function storageListen(storageArea) {
  return function listen(key, cb) {
    if (typeof key === 'function') {
      cb = key;
      key = '';
    }
    if (typeof key !== 'string') {
      throw new TypeError('Argument 1 should be string when argument 2 is a function.');
    }
    if (typeof cb !== 'function') {
      throw new TypeError('Callback should be a function.');
    }

    let listeners = storageListeners.get(cb);
    if (!listeners) {
      listeners = new Map();
      storageListeners.set(cb, listeners);
    }
    let callback = listeners.get(key);
    if (!callback) {
      callback = (changes, areaName) => {
        if (storageArea && areaName !== storageArea) {
          return;
        }
        if (!key || changes[key]) {
          cb(changes, areaName);
        }
      };
      listeners.set(key, callback);
    }
    return chrome.storage.onChanged.addListener(callback);
  };
}

function storageStopListen(listener, key) {
  const listeners = storageListeners.get(listener);
  if (listeners) {
    if (typeof key === 'string') {
      const callback = listeners.get(key);
      if (callback) {
        listeners.delete(key);
        if (listeners.size <= 0) {
          storageListeners.delete(listener);
        }
        return chrome.storage.onChanged.removeListener(callback);
      }
    } else {
      Array.from(listeners.values()).forEach(callback => {
        chrome.storage.onChanged.removeListener(callback);
      });
      storageListeners.delete(listener);
    }
  } else {
    return chrome.storage.onChanged.removeListener(listener);
  }
}

function storageClear(storageArea) {
  return function clear(cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].clear();
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].clear(() => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function storageRemove(storageArea) {
  return function remove(keys, cb) {
    if (typeof cb === 'function') {
      return chrome.storage[storageArea].remove(keys, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.storage[storageArea].remove(keys, () => {
          if (chrome.runtime.lastError) {
            reject(chrome.runtime.lastError.message);
          } else {
            resolve();
          }
        });
      });
    }
  };
}

function messageSend(...args) {
  if (args[0] === Object(args[0])) {
    let [message, cb] = args;
    if (typeof cb === 'function') {
      return chrome.runtime.sendMessage(message, cb);
    } else {
      return new Promise((resolve, reject) => {
        chrome.runtime.sendMessage(message, response => {
          resolve(response);
        });
      });
    }
  }

  let [tabId, message, cb] = args;
  if (typeof cb === 'function') {
    return chrome.tabs.sendMessage(tabId, message, cb);
  } else {
    return new Promise((resolve, reject) => {
      chrome.tabs.sendMessage(tabId, message, response => {
        resolve(response);
      });
    });
  }
}

function messageListen(msg, cb) {
  if (typeof msg === 'function') {
    cb = msg;
    msg = '';
  }
  if (typeof msg !== 'string') {
    throw new TypeError('Argument 1 should be string when argument 2 is a function.');
  }
  if (typeof cb !== 'function') {
    throw new TypeError('Callback should be a function.');
  }

  let listeners = messageListeners.get(cb);
  if (!listeners) {
    listeners = new Map();
    messageListeners.set(cb, listeners);
  }
  let callback = listeners.get(msg);
  if (!callback) {
    callback = msg ? (message, sender, sendResponse) => {
      if (message && message.msg === msg) {
        return cb(message, sender, sendResponse);
      }
    } : cb;
    listeners.set(msg, callback);
  }
  return chrome.runtime.onMessage.addListener(callback);
}

function messageStopListen(listener, msg) {
  const listeners = messageListeners.get(listener);
  if (listeners) {
    if (typeof msg === 'string') {
      const callback = listeners.get(msg);
      if (callback) {
        listeners.delete(msg);
        if (listeners.size <= 0) {
          messageListeners.delete(listener);
        }
        return chrome.runtime.onMessage.removeListener(callback);
      }
    } else {
      Array.from(listeners.values()).forEach(callback => {
        chrome.runtime.onMessage.removeListener(callback);
      });
      messageListeners.delete(listener);
    }
  } else {
    return chrome.runtime.onMessage.removeListener(listener);
  }
}

function messageSendSelf(message, cb) {
  if (message !== Object(message)) {
    throw new TypeError('arg 1 should be an object');
  }

  message.msg = `_&_${message.msg}_&_`;
  if (typeof cb === 'function') {
    if (typeof window.pageId === 'undefined') {
      return chrome.runtime.sendMessage({ msg: '__PAGE_INFO__' }, ({ pageId, faviconURL, pageTitle, pageURL }) => {
        window.pageId = pageId;
        window.faviconURL = faviconURL;
        if (pageTitle) {
          window.pageTitle = pageTitle;
        }
        if (pageURL) {
          window.pageURL = pageURL;
        }
        message.__pageId__ = pageId;
        debugMsg('SELF send %s on %s (request page id)', message.msg, window.pageId);
        chrome.runtime.sendMessage(message, cb);
      });
    } else {
      message.__pageId__ = window.pageId;
      debugMsg('SELF send %s on %s', message.msg, window.pageId);
      return chrome.runtime.sendMessage(message, cb);
    }
  } else {
    if (typeof window.pageId === 'undefined') {
      return messageSend({ msg: '__PAGE_INFO__' }).then(({ pageId, faviconURL, pageTitle, pageURL }) => {
        window.pageId = pageId;
        window.faviconURL = faviconURL;
        if (pageTitle) {
          window.pageTitle = pageTitle;
        }
        if (pageURL) {
          window.pageURL = pageURL;
        }
        message.__pageId__ = pageId;
        debugMsg('SELF send %s on %s (request page id)', message.msg, window.pageId);
        return messageSend(message);
      });
    } else {
      message.__pageId__ = window.pageId;
      debugMsg('SELF send %s on %s', message.msg, window.pageId);
      return messageSend(message);
    }
  }
}

function messageListenSelf(msg, cb) {
  if (typeof window.pageId === 'undefined') {
    chrome.runtime.sendMessage({ msg: '__PAGE_INFO__' }, ({ pageId, faviconURL, pageTitle, pageURL }) => {
      window.pageId = pageId;
      window.faviconURL = faviconURL;
      if (pageTitle) {
        window.pageTitle = pageTitle;
      }
      if (pageURL) {
        window.pageURL = pageURL;
      }
    });
  }

  if (typeof msg === 'function') {
    cb = msg;
    msg = '';
  }
  if (typeof msg !== 'string') {
    throw new TypeError('Argument 1 should be string when argument 2 is a function.');
  }
  if (typeof cb !== 'function') {
    throw new TypeError('Callback should be a function.');
  }

  let listeners = messageListeners.get(cb);
  if (!listeners) {
    listeners = new Map();
    messageListeners.set(cb, listeners);
  }
  let callback = listeners.get(msg);
  if (!callback) {
    callback = (message, sender, sendResponse) => {
      if (message && window.pageId === message.__pageId__) {
        if (!msg || message.msg === msg) {
          debugMsg('SELF Received %s on %s', msg, window.pageId);
          return cb(message, sender, sendResponse);
        }
      }
    };
    listeners.set(msg, callback);
  }
  debugMsg('SELF Listening to %s on %s', msg, window.pageId);
  return chrome.runtime.onMessage.addListener(callback);
}

const selfMsgTester = /^_&_(.+)_&_$/;

function initServer() {
  window.pageId = 'background page';
  chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
    if (!message) {
      return;
    }

    const selfMsg = selfMsgTester.exec(message.msg);
    if (selfMsg) {
      debugMsg('SELF Received %s from %s', message.msg, getPageInfo(sender).pageId);
      message.msg = selfMsg[1];
      if (sender.tab) {
        messageSend(sender.tab.id, message, response => {
          sendResponse(response);
        });
      } else {
        messageSend(message, response => {
          sendResponse(response);
        });
      }

      return true;
    }

    switch (message.msg) {
      case '__PAGE_INFO__':
        sendResponse(getPageInfo(sender));
        break;
      default:
        break;
    }
  });
}

function getPageInfo(sender) {
  const result = {
    faviconURL: ''
  };
  const tab = sender.tab;
  if (tab) {
    result.pageId = tab.id;
    if (tab.favIconUrl) {
      result.faviconURL = tab.favIconUrl;
    }
    if (tab.url) {
      result.pageURL = tab.url;
    }
    if (tab.title) {
      result.pageTitle = tab.title;
    }
  } else {
    result.pageId = 'popup';
    if (sender.url && sender.url.startsWith('chrome')) {
      result.favIconUrl = chrome.runtime.getURL('assets/icon-16.png');
    }
  }
  return result;
}

function _openURL(url, callback) {
  chrome.tabs.query({ url }, tabs => {
    if (tabs.length > 0) {
      chrome.tabs.highlight({ tabs: tabs[0].index }, callback);
    } else {
      chrome.tabs.create({ url }, callback);
    }
  });
}

/***/ }),
/* 2 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 3 */,
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(5);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = "";
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)))

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(6);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),
/* 6 */
/***/ (function(module, exports) {

/**
 * Helpers.
 */

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var y = d * 365.25;

/**
 * Parse or format the given `val`.
 *
 * Options:
 *
 *  - `long` verbose formatting [false]
 *
 * @param {String|Number} val
 * @param {Object} [options]
 * @throws {Error} throw an error if val is not a non-empty string or a number
 * @return {String|Number}
 * @api public
 */

module.exports = function(val, options) {
  options = options || {};
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse(val);
  } else if (type === 'number' && isNaN(val) === false) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error(
    'val is not a non-empty string or a valid number. val=' +
      JSON.stringify(val)
  );
};

/**
 * Parse the given `str` and return milliseconds.
 *
 * @param {String} str
 * @return {Number}
 * @api private
 */

function parse(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
    str
  );
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}

/**
 * Short format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtShort(ms) {
  if (ms >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (ms >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (ms >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (ms >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}

/**
 * Long format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtLong(ms) {
  return plural(ms, d, 'day') ||
    plural(ms, h, 'hour') ||
    plural(ms, m, 'minute') ||
    plural(ms, s, 'second') ||
    ms + ' ms';
}

/**
 * Pluralization helper.
 */

function plural(ms, n, name) {
  if (ms < n) {
    return;
  }
  if (ms < n * 1.5) {
    return Math.floor(ms / n) + ' ' + name;
  }
  return Math.ceil(ms / n) + ' ' + name + 's';
}


/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = fetchDom;

function fetchDom(url, options) {
  if (typeof url !== 'string') {
    throw new TypeError('argument 1 has to be string');
  }

  url = encodeURI(url.replace('\n', ' '));

  if (options && /^post$/i.test(options.method)) {
    return postHandler(url, options.body);
  }

  return getHandler(url);
}

function getHandler(url) {
  return new Promise((resolve, reject) => {
    let xhr = new XMLHttpRequest();
    xhr.onload = function () {
      if (xhr.status !== 200) {
        return reject('Response code ' + xhr.status);
      }
      resolve(xhr.responseXML);
    };
    xhr.onerror = function (e) {
      reject(e.toString());
    };
    xhr.open('GET', url);
    xhr.responseType = 'document';
    xhr.send();
  });
}

function postHandler(url, body) {
  return new Promise((resolve, reject) => {
    let xhr = new XMLHttpRequest();
    xhr.onload = function () {
      if (xhr.status !== 200) {
        return reject('Response code ' + xhr.status);
      }
      resolve(xhr.responseXML);
    };
    xhr.onerror = function (e) {
      reject(e.toString());
    };
    xhr.open('POST', url);
    xhr.responseType = 'document';
    body ? xhr.send(body) : xhr.send();
  });
}

/***/ }),
/* 8 */,
/* 9 */,
/* 10 */,
/* 11 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = stripScript;


const ALLOW_TAGS = new Set(['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'address', 'article', 'aside', 'footer', 'header', 'hgroup', 'nav', 'sectio', 'blockquote', 'dd', 'div', 'dl', 'dt', 'figcaption', 'figure', 'hr', 'li', 'main', 'ol', 'p', 'pre', 'ul', 'a', 'abbr', 'b', 'bdi', 'bdo', 'br', 'cite', 'code', 'data', 'dfn', 'em', 'i', 'kbd', 'mark', 'q', 'rp', 'rt', 'rtc', 'ruby', 's', 'samp', 'small', 'span', 'strong', 'sub', 'sup', 'time', 'u', 'var', 'wbr', 'img', 'del', 'ins', 'caption', 'col', 'colgroup', 'table', 'tbody', 'td', 'tfoot', 'th', 'thead', 'tr']);
/* unused harmony export ALLOW_TAGS */


function stripScript(node, allowTags = ALLOW_TAGS) {
  if (!node) {
    return null;
  }
  if (node.nodeType === Node.TEXT_NODE) {
    return node.cloneNode();
  }
  if (node.nodeType !== Node.ELEMENT_NODE) {
    return null;
  }

  const tagName = node.tagName.toLowerCase();

  if (!allowTags.has(tagName)) {
    return null;
  }

  const newNode = document.createElement(tagName);
  if (tagName === 'img') {
    if (/^(https?:)?\/\//.test(node.src)) {
      newNode.setAttribute('src', node.scr);
    } else {
      return null;
    }
  } else if (tagName === 'a') {
    if (/^(https?:)?\/\//.test(node.href)) {
      newNode.setAttribute('href', node.href);
      newNode.setAttribute('target', '_blank');
    } else {
      return null;
    }
  }

  if (node.className) {
    newNode.className = node.className;
  }
  if (node.id) {
    newNode.id = node.id;
  }

  node.childNodes.forEach(childNode => {
    const newChildNode = stripScript(childNode, allowTags);
    if (newChildNode != null) {
      newNode.appendChild(newChildNode);
    }
  });

  return newNode;
}

/***/ }),
/* 12 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
const isContainChinese = function isContainChinese(text) {
  return (/[\u4e00-\u9fa5]/.test(text)
  );
};
/* harmony export (immutable) */ __webpack_exports__["a"] = isContainChinese;


const isContainEnglish = function isContainEnglish(text) {
  return (/[a-zA-Z]/.test(text)
  );
};
/* harmony export (immutable) */ __webpack_exports__["b"] = isContainEnglish;


/* unused harmony default export */ var _unused_webpack_default_export = ({
  isContainChinese,
  isContainEnglish
});

/***/ }),
/* 13 */,
/* 14 */,
/* 15 */,
/* 16 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

const promiseReflect = function promiseReflect(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  return Promise.all(iterable.map(p => Promise.resolve(p).catch(() => null)));
};
/* harmony export (immutable) */ __webpack_exports__["a"] = promiseReflect;


const promiseAny = function promiseAny(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  var rejectCount = 0;
  var reasons = [];
  var promises = iterable.map((p, i) => Promise.resolve(p).catch(e => {
    rejectCount++;
    reasons[i] = e;
    return null;
  }));

  return Promise.all(promises).then(resolutions => {
    if (rejectCount === resolutions.length) {
      return Promise.reject(reasons);
    }
    return resolutions;
  });
};
/* unused harmony export promiseAny */


const promiseFirst = function promiseFirst(iterable) {
  if (!Array.isArray(iterable)) {
    iterable = Array.from(iterable);
  }

  var rejectCount = 0;
  var reasons = [];
  return new Promise((resolve, reject) => iterable.forEach((p, i) => {
    Promise.resolve(p).then(resolve).catch(e => {
      reasons[i] = e;
      if (++rejectCount === iterable.length) {
        reject(reasons);
      }
    });
  }));
};
/* unused harmony export promiseFirst */


const promiseTimer = function promiseTimer(delay = 0) {
  return new Promise(resolve => {
    var id = setTimeout(() => resolve(id), Number(delay) || 0);
  });
};
/* harmony export (immutable) */ __webpack_exports__["b"] = promiseTimer;


const promiseTimeout = function promiseTimeout(pr, delay = 0) {
  delay = Number(delay);
  return new Promise((resolve, reject) => {
    Promise.resolve(pr).then(resolve, reject);
    if (delay > 0) {
      promiseTimer(delay).then(() => {
        reject(new Error(`timeout ${delay}ms`));
      });
    }
  });
};
/* unused harmony export promiseTimeout */


/* unused harmony default export */ var _unused_webpack_default_export = ({
  reflect: promiseReflect,
  any: promiseAny,
  first: promiseFirst,
  timer: promiseTimer,
  timeout: promiseTimeout
});

/***/ }),
/* 17 */,
/* 18 */,
/* 19 */,
/* 20 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = chsToChz;
const charMap = {
  '与': '與',
  '丒': '囟',
  '专': '專',
  '丗': '卅',
  '业': '業',
  '丛': '叢',
  '东': '東',
  '丝': '絲',
  '両': '兩',
  '丢': '丟',
  '两': '兩',
  '严': '嚴',
  '丧': '喪',
  '个': '個',
  '丬': '爿',
  '丯': '丰',
  '临': '臨',
  '丶': '⼂',
  '为': '為',
  '丽': '麗',
  '举': '舉',
  '义': '義',
  '乌': '烏',
  '乐': '樂',
  '乔': '喬',
  '习': '習',
  '乡': '鄉',
  '书': '書',
  '买': '買',
  '乱': '亂',
  '亀': '龜',
  '亁': '乾',
  '争': '爭',
  '亏': '虧',
  '亘': '亙',
  '亚': '亞',
  '产': '產',
  '亩': '畝',
  '亲': '親',
  '亵': '褻',
  '亸': '嚲',
  '亻': '人',
  '亿': '億',
  '仅': '僅',
  '从': '從',
  '仑': '崙',
  '仓': '倉',
  '仪': '儀',
  '们': '們',
  '仮': '假',
  '众': '眾',
  '会': '會',
  '伛': '傴',
  '伞': '傘',
  '伟': '偉',
  '传': '傳',
  '伤': '傷',
  '伥': '倀',
  '伦': '倫',
  '伧': '傖',
  '伪': '偽',
  '伫': '佇',
  '体': '體',
  '佥': '僉',
  '侠': '俠',
  '侣': '侶',
  '侥': '僥',
  '侦': '偵',
  '侧': '側',
  '侨': '僑',
  '侩': '儈',
  '侪': '儕',
  '侬': '儂',
  '俣': '俁',
  '俦': '儔',
  '俨': '儼',
  '俩': '倆',
  '俪': '儷',
  '俭': '儉',
  '债': '債',
  '倾': '傾',
  '偬': '傯',
  '偻': '僂',
  '偾': '僨',
  '偿': '償',
  '傥': '儻',
  '傧': '儐',
  '储': '儲',
  '傩': '儺',
  '兎': '兔',
  '兑': '兌',
  '兖': '兗',
  '兪': '俞',
  '兰': '蘭',
  '关': '關',
  '兴': '興',
  '兹': '茲',
  '养': '養',
  '兽': '獸',
  '兾': '糞',
  '兿': '藝',
  '冁': '囅',
  '内': '內',
  '円': '丹',
  '冈': '岡',
  '册': '冊',
  '写': '寫',
  '军': '軍',
  '农': '農',
  '冝': '宜',
  '冦': '寇',
  '冧': '霖',
  '冨': '富',
  '冩': '寫',
  '冮': '江',
  '冯': '馮',
  '冲': '沖',
  '决': '決',
  '况': '況',
  '冸': '泮',
  '冺': '泯',
  '冻': '凍',
  '冿': '津',
  '净': '淨',
  '凁': '涑',
  '凂': '浼',
  '凃': '涂',
  '凄': '淒',
  '凉': '涼',
  '减': '減',
  '凑': '湊',
  '凒': '溰',
  '凓': '溧',
  '凕': '溟',
  '凖': '準',
  '凙': '澤',
  '凛': '凜',
  '凟': '瀆',
  '凤': '鳳',
  '凥': '尻',
  '処': '處',
  '凨': '云',
  '凫': '鳧',
  '凬': '凰',
  '凭': '憑',
  '凮': '鳳',
  '凯': '凱',
  '凴': '憑',
  '击': '擊',
  '凼': '窞',
  '凾': '亟',
  '凿': '鑿',
  '刄': '刃',
  '刅': '刃',
  '刋': '刊',
  '刍': '芻',
  '刘': '劉',
  '则': '則',
  '刚': '剛',
  '创': '創',
  '删': '刪',
  '刦': '劫',
  '刧': '劫',
  '别': '別',
  '刭': '剄',
  '刴': '剁',
  '刹': '剎',
  '刼': '劫',
  '刽': '劊',
  '刿': '劌',
  '剀': '剴',
  '剂': '劑',
  '剐': '剮',
  '剑': '劍',
  '剥': '剝',
  '剧': '劇',
  '剰': '剩',
  '劎': '劍',
  '劒': '劍',
  '劔': '劍',
  '劝': '勸',
  '办': '辦',
  '务': '務',
  '劢': '勱',
  '动': '動',
  '励': '勵',
  '劲': '勁',
  '劳': '勞',
  '労': '勞',
  '劵': '卷',
  '効': '效',
  '劽': '裂',
  '势': '勢',
  '勅': '敕',
  '勋': '勛',
  '勐': '猛',
  '勚': '勩',
  '勠': '戮',
  '勥': '強',
  '勧': '勸',
  '匀': '勻',
  '匦': '匭',
  '匮': '匱',
  '区': '區',
  '医': '醫',
  '华': '華',
  '协': '協',
  '单': '單',
  '卖': '賣',
  '単': '單',
  '卙': '斟',
  '卛': '攣',
  '卟': '嚇',
  '卢': '盧',
  '卤': '鹵',
  '卥': '囟',
  '卧': '臥',
  '卫': '衛',
  '却': '卻',
  '卺': '巹',
  '厅': '廳',
  '历': '歷',
  '厉': '厲',
  '压': '壓',
  '厌': '厭',
  '厕': '廁',
  '厛': '廳',
  '厠': '廁',
  '厢': '廂',
  '厣': '厴',
  '厦': '廈',
  '厨': '廚',
  '厩': '廄',
  '厮': '廝',
  '厰': '廠',
  '厳': '嚴',
  '厶': '⼛',
  '县': '縣',
  '叁': '參',
  '叄': '參',
  '叆': '靉',
  '叇': '靆',
  '双': '雙',
  '収': '收',
  '叏': '發',
  '叐': '發',
  '发': '發',
  '变': '變',
  '叙': '敘',
  '叠': '疊',
  '叧': '另',
  '叶': '葉',
  '号': '號',
  '叹': '嘆',
  '叽': '嘰',
  '吓': '嚇',
  '吕': '呂',
  '吖': '嗄',
  '吗': '嗎',
  '吣': '唚',
  '吨': '噸',
  '启': '啟',
  '吴': '吳',
  '吿': '告',
  '呋': '咐',
  '呐': '吶',
  '呑': '吞',
  '呒': '嘸',
  '呓': '囈',
  '呕': '嘔',
  '呖': '嚦',
  '呗': '唄',
  '员': '員',
  '呙': '咼',
  '呛': '嗆',
  '呜': '嗚',
  '呪': '咒',
  '咏': '詠',
  '咙': '嚨',
  '咛': '嚀',
  '咝': '吱',
  '咣': '光',
  '咤': '吒',
  '哌': '呱',
  '响': '響',
  '哐': '匡',
  '哑': '啞',
  '哒': '噠',
  '哓': '嘵',
  '哔': '嗶',
  '哕': '噦',
  '哗': '嘩',
  '哙': '噲',
  '哜': '嚌',
  '哝': '噥',
  '哟': '喲',
  '唝': '嗊',
  '唠': '嘮',
  '唡': '啢',
  '唢': '嗩',
  '唣': '嗦',
  '唤': '喚',
  '唿': '呼',
  '啧': '嘖',
  '啬': '嗇',
  '啭': '囀',
  '啰': '囉',
  '啴': '嘽',
  '啸': '嘯',
  '喷': '噴',
  '喹': '奎',
  '喽': '嘍',
  '喾': '嚳',
  '嗪': '唚',
  '嗫': '囁',
  '嗬': '呵',
  '嗳': '噯',
  '嗵': '通',
  '嘘': '噓',
  '嘞': '咧',
  '嘠': '嘎',
  '嘣': '迸',
  '嘤': '嚶',
  '嘨': '嘯',
  '嘭': '膨',
  '嘱': '囑',
  '嘷': '嚎',
  '噜': '嚕',
  '噻': '塞',
  '噼': '劈',
  '嚔': '涕',
  '嚢': '囊',
  '嚣': '囂',
  '嚯': '謔',
  '团': '團',
  '园': '園',
  '囱': '囪',
  '围': '圍',
  '囵': '圇',
  '国': '國',
  '图': '圖',
  '圆': '圓',
  '圣': '聖',
  '圹': '壙',
  '场': '場',
  '块': '塊',
  '坚': '堅',
  '坛': '壇',
  '坜': '壢',
  '坝': '壩',
  '坞': '塢',
  '坟': '墳',
  '坠': '墜',
  '垄': '壟',
  '垅': '壟',
  '垆': '壚',
  '垒': '壘',
  '垦': '墾',
  '垧': '坰',
  '垩': '堊',
  '垫': '墊',
  '垲': '塏',
  '垴': '瑙',
  '埘': '塒',
  '埚': '堝',
  '堑': '塹',
  '堕': '墮',
  '塡': '填',
  '塬': '原',
  '墙': '牆',
  '壮': '壯',
  '声': '聲',
  '壳': '殼',
  '壶': '壺',
  '壸': '壼',
  '夂': '⼢',
  '处': '處',
  '备': '備',
  '夊': '⼢',
  '够': '夠',
  '头': '頭',
  '夹': '夾',
  '夺': '奪',
  '奁': '奩',
  '奂': '奐',
  '奋': '奮',
  '奖': '獎',
  '奥': '奧',
  '妆': '妝',
  '妇': '婦',
  '妈': '媽',
  '妩': '嫵',
  '妪': '嫗',
  '妫': '媯',
  '姗': '姍',
  '姹': '奼',
  '娄': '婁',
  '娅': '婭',
  '娆': '嬈',
  '娇': '嬌',
  '娈': '孌',
  '娱': '娛',
  '娲': '媧',
  '娴': '嫻',
  '婳': '嫿',
  '婴': '嬰',
  '婵': '嬋',
  '婶': '嬸',
  '媪': '媼',
  '嫒': '嬡',
  '嫔': '嬪',
  '嫱': '嬙',
  '嬷': '嬤',
  '孙': '孫',
  '学': '學',
  '孪': '孿',
  '孶': '孳',
  '宝': '寶',
  '实': '實',
  '宠': '寵',
  '审': '審',
  '宪': '憲',
  '宫': '宮',
  '宽': '寬',
  '宾': '賓',
  '寝': '寢',
  '对': '對',
  '寻': '尋',
  '导': '導',
  '対': '對',
  '寿': '壽',
  '専': '專',
  '尅': '剋',
  '将': '將',
  '尓': '爾',
  '尔': '爾',
  '尘': '塵',
  '尝': '嘗',
  '尧': '堯',
  '尴': '尷',
  '尽': '盡',
  '层': '層',
  '屃': '屭',
  '屉': '屜',
  '届': '屆',
  '屛': '屏',
  '属': '屬',
  '屡': '屢',
  '屦': '屨',
  '屿': '嶼',
  '岁': '歲',
  '岂': '豈',
  '岖': '嶇',
  '岗': '崗',
  '岘': '峴',
  '岙': '嶴',
  '岚': '嵐',
  '岛': '島',
  '岭': '嶺',
  '岿': '巋',
  '峄': '嶧',
  '峡': '峽',
  '峣': '嶢',
  '峤': '嶠',
  '峥': '崢',
  '峦': '巒',
  '峯': '峰',
  '崂': '嶗',
  '崃': '崍',
  '崄': '嶮',
  '崭': '嶄',
  '崾': '要',
  '嵘': '嶸',
  '嵚': '嶔',
  '嵝': '嶁',
  '巄': '巃',
  '巅': '巔',
  '巌': '巖',
  '巓': '巔',
  '巩': '鞏',
  '币': '幣',
  '帅': '帥',
  '师': '師',
  '帏': '幃',
  '帐': '帳',
  '帜': '幟',
  '带': '帶',
  '帧': '幀',
  '帮': '幫',
  '帯': '帶',
  '帱': '幬',
  '帻': '幘',
  '帼': '幗',
  '幂': '冪',
  '幇': '幫',
  '幚': '幫',
  '幞': '襆',
  '幷': '并',
  '广': '廣',
  '庁': '廳',
  '広': '麼',
  '庄': '莊',
  '庅': '麼',
  '庆': '慶',
  '庐': '廬',
  '庑': '廡',
  '库': '庫',
  '应': '應',
  '庙': '廟',
  '庞': '龐',
  '废': '廢',
  '庼': '廎',
  '廏': '廄',
  '廐': '廄',
  '廪': '廩',
  '廴': '⼵',
  '廵': '巡',
  '开': '開',
  '异': '異',
  '弃': '棄',
  '弑': '弒',
  '张': '張',
  '弥': '彌',
  '弯': '彎',
  '弹': '彈',
  '强': '強',
  '归': '歸',
  '当': '當',
  '录': '錄',
  '彚': '彙',
  '彛': '羿',
  '彜': '羿',
  '彟': '獲',
  '彠': '獲',
  '彡': '⼺',
  '彦': '彥',
  '彻': '徹',
  '径': '徑',
  '徕': '徠',
  '徸': '德',
  '忄': '心',
  '忆': '憶',
  '忏': '懺',
  '忧': '憂',
  '忾': '愾',
  '怀': '懷',
  '态': '態',
  '怂': '慫',
  '怃': '憮',
  '怅': '悵',
  '怆': '愴',
  '怜': '憐',
  '总': '總',
  '怼': '懟',
  '怿': '懌',
  '恋': '戀',
  '恒': '恆',
  '恳': '懇',
  '恶': '惡',
  '恸': '慟',
  '恹': '懨',
  '恺': '愷',
  '恻': '惻',
  '恼': '惱',
  '恽': '惲',
  '悦': '悅',
  '悫': '愨',
  '悬': '懸',
  '悭': '慳',
  '悯': '憫',
  '惊': '驚',
  '惧': '懼',
  '惨': '慘',
  '惩': '懲',
  '惫': '憊',
  '惬': '愜',
  '惭': '慚',
  '惮': '憚',
  '惯': '慣',
  '惽': '惛',
  '愠': '慍',
  '愤': '憤',
  '愦': '憒',
  '慑': '懾',
  '慭': '憖',
  '懑': '懣',
  '懒': '懶',
  '懔': '懍',
  '懴': '懺',
  '戅': '戇',
  '戆': '戇',
  '戋': '戔',
  '戏': '戲',
  '戗': '戧',
  '战': '戰',
  '戝': '敗',
  '戦': '戰',
  '戬': '戩',
  '戯': '戲',
  '戱': '戲',
  '户': '戶',
  '戸': '戶',
  '扌': '手',
  '执': '執',
  '扩': '擴',
  '扪': '捫',
  '扫': '掃',
  '扬': '揚',
  '扰': '擾',
  '抅': '拘',
  '抚': '撫',
  '抛': '拋',
  '抟': '摶',
  '抠': '摳',
  '抡': '掄',
  '抢': '搶',
  '护': '護',
  '报': '報',
  '担': '擔',
  '拟': '擬',
  '拢': '攏',
  '拣': '揀',
  '拥': '擁',
  '拦': '攔',
  '拧': '擰',
  '拨': '撥',
  '择': '擇',
  '挚': '摯',
  '挛': '攣',
  '挜': '掗',
  '挝': '撾',
  '挞': '撻',
  '挟': '挾',
  '挠': '撓',
  '挡': '擋',
  '挢': '撟',
  '挣': '掙',
  '挤': '擠',
  '挥': '揮',
  '挦': '撏',
  '捞': '撈',
  '损': '損',
  '捡': '撿',
  '换': '換',
  '捣': '搗',
  '掳': '擄',
  '掴': '摑',
  '掷': '擲',
  '掸': '撣',
  '掺': '摻',
  '掼': '摜',
  '揸': '喳',
  '揽': '攬',
  '揿': '撳',
  '搀': '攙',
  '搁': '擱',
  '搂': '摟',
  '搃': '摠',
  '搅': '攪',
  '携': '攜',
  '摄': '攝',
  '摅': '攄',
  '摆': '擺',
  '摇': '搖',
  '摈': '擯',
  '摊': '攤',
  '撃': '擊',
  '撄': '攖',
  '撑': '撐',
  '撪': '攆',
  '撵': '攆',
  '撷': '擷',
  '撹': '攪',
  '撺': '攛',
  '擕': '攜',
  '擞': '擻',
  '擡': '抬',
  '擥': '掔',
  '擧': '舉',
  '擪': '壓',
  '攒': '攢',
  '攵': '又',
  '敇': '敕',
  '敌': '敵',
  '敛': '斂',
  '敮': '歃',
  '数': '數',
  '斉': '齊',
  '斋': '齋',
  '斎': '齋',
  '斓': '斕',
  '斩': '斬',
  '断': '斷',
  '旧': '舊',
  '时': '時',
  '旷': '曠',
  '旸': '暘',
  '昙': '曇',
  '昼': '晝',
  '昽': '曨',
  '显': '顯',
  '晋': '晉',
  '晓': '曉',
  '晔': '曄',
  '晕': '暈',
  '晖': '暉',
  '暂': '暫',
  '暧': '曖',
  '术': '術',
  '杀': '殺',
  '杂': '雜',
  '权': '權',
  '条': '條',
  '来': '來',
  '杨': '楊',
  '极': '極',
  '枞': '樅',
  '枢': '樞',
  '枣': '棗',
  '枥': '櫪',
  '枧': '見',
  '枨': '棖',
  '枪': '槍',
  '枫': '楓',
  '枭': '梟',
  '柠': '檸',
  '柽': '檉',
  '栀': '梔',
  '栅': '柵',
  '标': '標',
  '栈': '棧',
  '栉': '櫛',
  '栊': '櫳',
  '栋': '棟',
  '栌': '櫨',
  '栎': '櫟',
  '栏': '欄',
  '树': '樹',
  '样': '樣',
  '栾': '欒',
  '桊': '棬',
  '桠': '椏',
  '桡': '橈',
  '桢': '楨',
  '档': '檔',
  '桤': '榿',
  '桥': '橋',
  '桦': '樺',
  '桧': '檜',
  '桨': '槳',
  '桩': '樁',
  '梦': '夢',
  '梼': '檮',
  '梾': '棶',
  '检': '檢',
  '棂': '欞',
  '椁': '槨',
  '椟': '櫝',
  '椠': '槧',
  '椭': '橢',
  '楼': '樓',
  '楽': '樂',
  '榄': '欖',
  '榇': '櫬',
  '榈': '櫚',
  '榉': '櫸',
  '榘': '矩',
  '槚': '檟',
  '槛': '檻',
  '槟': '檳',
  '槠': '櫧',
  '横': '橫',
  '樯': '檣',
  '樱': '櫻',
  '橥': '櫫',
  '橱': '櫥',
  '橹': '櫓',
  '橼': '櫞',
  '檪': '櫟',
  '檫': '察',
  '欢': '歡',
  '欤': '歟',
  '欧': '歐',
  '歳': '歲',
  '歴': '曆',
  '歺': '歲',
  '歼': '殲',
  '殁': '歿',
  '殇': '殤',
  '残': '殘',
  '殒': '殞',
  '殓': '殮',
  '殚': '殫',
  '殡': '殯',
  '殱': '殲',
  '殴': '毆',
  '毁': '毀',
  '毂': '轂',
  '毕': '畢',
  '毙': '斃',
  '毡': '氈',
  '毵': '毿',
  '毶': '鞠',
  '気': '氣',
  '氢': '氫',
  '氩': '氬',
  '氲': '氳',
  '氵': '水',
  '氽': '汆',
  '汇': '匯',
  '汉': '漢',
  '污': '汙',
  '汤': '湯',
  '汹': '洶',
  '沟': '溝',
  '没': '沒',
  '沣': '灃',
  '沤': '漚',
  '沥': '瀝',
  '沦': '淪',
  '沧': '滄',
  '沨': '渢',
  '沩': '溈',
  '沪': '滬',
  '沵': '濔',
  '泞': '濘',
  '泪': '淚',
  '泶': '澩',
  '泷': '瀧',
  '泸': '瀘',
  '泺': '濼',
  '泻': '瀉',
  '泼': '潑',
  '泽': '澤',
  '泾': '涇',
  '洁': '潔',
  '浃': '浹',
  '浅': '淺',
  '浆': '漿',
  '浇': '澆',
  '浈': '湞',
  '浊': '濁',
  '测': '測',
  '浍': '澮',
  '济': '濟',
  '浏': '瀏',
  '浐': '滻',
  '浑': '渾',
  '浒': '滸',
  '浓': '濃',
  '浔': '潯',
  '浕': '濜',
  '浜': '濱',
  '涙': '淚',
  '涛': '濤',
  '涝': '澇',
  '涞': '淶',
  '涟': '漣',
  '涡': '渦',
  '涣': '渙',
  '涤': '滌',
  '润': '潤',
  '涧': '澗',
  '涨': '漲',
  '涩': '澀',
  '淀': '澱',
  '渊': '淵',
  '渌': '淥',
  '渍': '漬',
  '渎': '瀆',
  '渐': '漸',
  '渑': '澠',
  '渔': '漁',
  '渖': '瀋',
  '渗': '滲',
  '温': '溫',
  '湼': '涅',
  '湾': '灣',
  '湿': '濕',
  '溃': '潰',
  '溅': '濺',
  '溆': '漵',
  '溇': '漊',
  '滙': '匯',
  '滚': '滾',
  '滝': '瀧',
  '滞': '滯',
  '滟': '灩',
  '滠': '灄',
  '满': '滿',
  '滢': '瀅',
  '滤': '濾',
  '滥': '濫',
  '滦': '灤',
  '滨': '濱',
  '滩': '灘',
  '滪': '澦',
  '漑': '溉',
  '潆': '瀠',
  '潇': '瀟',
  '潋': '瀲',
  '潍': '濰',
  '潜': '潛',
  '潴': '瀦',
  '澜': '瀾',
  '濑': '瀨',
  '濒': '瀕',
  '灎': '灩',
  '灏': '灝',
  '灔': '灩',
  '灜': '瀛',
  '灧': '灩',
  '灬': '火',
  '灭': '滅',
  '灯': '燈',
  '灵': '靈',
  '灾': '災',
  '灿': '燦',
  '炀': '煬',
  '炉': '爐',
  '炖': '燉',
  '炜': '煒',
  '炝': '熗',
  '点': '點',
  '炼': '煉',
  '炽': '熾',
  '烁': '爍',
  '烂': '爛',
  '烃': '烴',
  '烛': '燭',
  '烟': '煙',
  '烦': '煩',
  '烧': '燒',
  '烨': '燁',
  '烩': '燴',
  '烫': '燙',
  '烬': '燼',
  '热': '熱',
  '焕': '煥',
  '焖': '燜',
  '焘': '燾',
  '煅': '煆',
  '煳': '糊',
  '煺': '退',
  '熘': '溜',
  '爱': '愛',
  '爲': '為',
  '爷': '爺',
  '牍': '牘',
  '牜': '牛',
  '牦': '犛',
  '牵': '牽',
  '牺': '犧',
  '犊': '犢',
  '犟': '強',
  '犭': '犬',
  '状': '狀',
  '犷': '獷',
  '犸': '馬',
  '犹': '猶',
  '狈': '狽',
  '狍': '包',
  '狝': '獮',
  '狞': '獰',
  '独': '獨',
  '狭': '狹',
  '狮': '獅',
  '狯': '獪',
  '狰': '猙',
  '狱': '獄',
  '狲': '猻',
  '猃': '獫',
  '猎': '獵',
  '猕': '獼',
  '猡': '玀',
  '猪': '豬',
  '猫': '貓',
  '猬': '蝟',
  '献': '獻',
  '獭': '獺',
  '玑': '璣',
  '玙': '璵',
  '玚': '瑒',
  '玛': '瑪',
  '玮': '瑋',
  '环': '環',
  '现': '現',
  '玱': '瑲',
  '玺': '璽',
  '珏': '玨',
  '珐': '琺',
  '珑': '瓏',
  '珰': '璫',
  '珱': '瓔',
  '珲': '琿',
  '琏': '璉',
  '琐': '瑣',
  '琼': '瓊',
  '瑶': '瑤',
  '瑷': '璦',
  '璎': '瓔',
  '瓒': '瓚',
  '瓯': '甌',
  '産': '產',
  '电': '電',
  '画': '畫',
  '畅': '暢',
  '畲': '畬',
  '畳': '疊',
  '畴': '疇',
  '畵': '畫',
  '疎': '疏',
  '疖': '癤',
  '疗': '療',
  '疟': '瘧',
  '疠': '癘',
  '疡': '瘍',
  '疬': '癆',
  '疮': '瘡',
  '疯': '瘋',
  '疴': '痾',
  '痈': '癰',
  '痉': '痙',
  '痖': '啞',
  '痨': '癆',
  '痩': '瘦',
  '痪': '瘓',
  '痫': '癇',
  '痬': '瘍',
  '瘅': '癉',
  '瘆': '疹',
  '瘗': '瘞',
  '瘘': '瘺',
  '瘪': '癟',
  '瘫': '癱',
  '瘾': '癮',
  '瘿': '癭',
  '癀': '廣',
  '癍': '斑',
  '癎': '癇',
  '癞': '癩',
  '癣': '癬',
  '癫': '癲',
  '発': '發',
  '皑': '皚',
  '皱': '皺',
  '皲': '皸',
  '盏': '盞',
  '盐': '鹽',
  '监': '監',
  '盖': '蓋',
  '盗': '盜',
  '盘': '盤',
  '県': '縣',
  '眍': '區',
  '眞': '真',
  '眦': '眥',
  '眬': '矓',
  '着': '著',
  '睁': '睜',
  '睐': '睞',
  '睑': '瞼',
  '瞒': '瞞',
  '瞩': '矚',
  '矤': '病',
  '矫': '矯',
  '矶': '磯',
  '矾': '礬',
  '矿': '礦',
  '砀': '碭',
  '码': '碼',
  '砖': '磚',
  '砗': '硨',
  '砚': '硯',
  '砜': '風',
  '砺': '礪',
  '砻': '礱',
  '砾': '礫',
  '础': '礎',
  '硁': '硜',
  '硕': '碩',
  '硖': '硤',
  '硗': '磽',
  '硙': '磑',
  '硚': '礄',
  '硷': '鹼',
  '碍': '礙',
  '碛': '磧',
  '碜': '磣',
  '碱': '鹼',
  '碹': '宣',
  '磙': '袞',
  '礻': '示',
  '礼': '禮',
  '祎': '禕',
  '祢': '禰',
  '祯': '禎',
  '祷': '禱',
  '祸': '禍',
  '禀': '稟',
  '禄': '祿',
  '禅': '禪',
  '离': '離',
  '秃': '禿',
  '秆': '稈',
  '积': '積',
  '称': '稱',
  '秽': '穢',
  '秾': '穠',
  '税': '稅',
  '稣': '穌',
  '稳': '穩',
  '穑': '穡',
  '穷': '窮',
  '窃': '竊',
  '窍': '竅',
  '窑': '窯',
  '窜': '竄',
  '窝': '窩',
  '窥': '窺',
  '窦': '竇',
  '窭': '窶',
  '竖': '豎',
  '竜': '龍',
  '竞': '競',
  '笃': '篤',
  '笋': '筍',
  '笔': '筆',
  '笕': '筧',
  '笺': '箋',
  '笼': '籠',
  '笾': '籩',
  '筚': '篳',
  '筛': '篩',
  '筜': '簹',
  '筝': '箏',
  '筹': '籌',
  '签': '簽',
  '简': '簡',
  '箓': '籙',
  '箢': '宛',
  '箦': '簀',
  '箧': '篋',
  '箨': '籜',
  '箩': '籮',
  '箪': '簞',
  '箫': '簫',
  '篑': '簣',
  '篓': '簍',
  '篮': '籃',
  '篱': '籬',
  '簖': '籪',
  '籁': '籟',
  '籴': '糴',
  '类': '類',
  '籼': '秈',
  '粜': '糶',
  '粝': '糲',
  '粤': '粵',
  '粪': '糞',
  '粮': '糧',
  '糁': '糝',
  '糇': '餱',
  '糹': '糸',
  '紧': '緊',
  '絵': '繪',
  '絶': '絕',
  '絷': '縶',
  '綘': '健',
  '継': '繼',
  '続': '續',
  '緜': '綿',
  '縂': '總',
  '縄': '繩',
  '繋': '繫',
  '繍': '繡',
  '纟': '糸',
  '纠': '糾',
  '纡': '紆',
  '红': '紅',
  '纣': '紂',
  '纤': '纖',
  '纥': '紇',
  '约': '約',
  '级': '級',
  '纨': '紈',
  '纩': '纊',
  '纪': '紀',
  '纫': '紉',
  '纬': '緯',
  '纭': '紜',
  '纮': '紘',
  '纯': '純',
  '纰': '紕',
  '纱': '紗',
  '纲': '綱',
  '纳': '納',
  '纴': '紝',
  '纵': '縱',
  '纶': '綸',
  '纷': '紛',
  '纸': '紙',
  '纹': '紋',
  '纺': '紡',
  '纻': '紵',
  '纼': '紖',
  '纽': '紐',
  '纾': '紓',
  '线': '線',
  '绀': '紺',
  '绁': '紲',
  '绂': '紱',
  '练': '練',
  '组': '組',
  '绅': '紳',
  '细': '細',
  '织': '織',
  '终': '終',
  '绉': '縐',
  '绊': '絆',
  '绋': '紼',
  '绌': '絀',
  '绍': '紹',
  '绎': '繹',
  '经': '經',
  '绐': '紿',
  '绑': '綁',
  '绒': '絨',
  '结': '結',
  '绔': '褲',
  '绕': '繞',
  '绖': '絰',
  '绗': '絎',
  '绘': '繪',
  '给': '給',
  '绚': '絢',
  '绛': '絳',
  '络': '絡',
  '绝': '絕',
  '绞': '絞',
  '统': '統',
  '绠': '綆',
  '绡': '綃',
  '绢': '絹',
  '绣': '繡',
  '绤': '綌',
  '绥': '綏',
  '绦': '絛',
  '继': '繼',
  '绨': '綈',
  '绩': '績',
  '绪': '緒',
  '绫': '綾',
  '续': '續',
  '绮': '綺',
  '绯': '緋',
  '绰': '綽',
  '绱': '鞜',
  '绲': '緄',
  '绳': '繩',
  '维': '維',
  '绵': '綿',
  '绶': '綬',
  '绷': '繃',
  '绸': '綢',
  '绹': '綯',
  '绺': '綹',
  '绻': '綣',
  '综': '綜',
  '绽': '綻',
  '绾': '綰',
  '绿': '綠',
  '缀': '綴',
  '缁': '緇',
  '缂': '緙',
  '缃': '緗',
  '缄': '緘',
  '缅': '緬',
  '缆': '纜',
  '缇': '緹',
  '缈': '緲',
  '缉': '緝',
  '缊': '縕',
  '缋': '繢',
  '缌': '緦',
  '缍': '綞',
  '缎': '緞',
  '缏': '緶',
  '缐': '線',
  '缑': '緱',
  '缒': '縋',
  '缓': '緩',
  '缔': '締',
  '缕': '縷',
  '编': '編',
  '缗': '緡',
  '缘': '緣',
  '缙': '縉',
  '缚': '縛',
  '缛': '縟',
  '缜': '縝',
  '缝': '縫',
  '缞': '縗',
  '缟': '縞',
  '缠': '纏',
  '缡': '縭',
  '缢': '縊',
  '缣': '縑',
  '缤': '繽',
  '缥': '縹',
  '缦': '縵',
  '缧': '縲',
  '缨': '纓',
  '缩': '縮',
  '缪': '繆',
  '缫': '繅',
  '缬': '纈',
  '缭': '繚',
  '缮': '繕',
  '缯': '繒',
  '缰': '韁',
  '缱': '繾',
  '缲': '繰',
  '缳': '繯',
  '缴': '繳',
  '缵': '纘',
  '罂': '罌',
  '罗': '羅',
  '罚': '罰',
  '罢': '罷',
  '罴': '羆',
  '羁': '羈',
  '羗': '羌',
  '羟': '羥',
  '羡': '羨',
  '羣': '群',
  '羮': '羹',
  '翘': '翹',
  '翙': '翽',
  '翚': '翬',
  '耢': '勞',
  '耥': '尚',
  '耧': '耬',
  '耸': '聳',
  '耻': '恥',
  '聂': '聶',
  '聋': '聾',
  '职': '職',
  '聍': '聹',
  '联': '聯',
  '聩': '聵',
  '聪': '聰',
  '肀': '聿',
  '肃': '肅',
  '肠': '腸',
  '肤': '膚',
  '肷': '欠',
  '肾': '腎',
  '肿': '腫',
  '胀': '脹',
  '胁': '脅',
  '胆': '膽',
  '胧': '朧',
  '胨': '東',
  '胪': '臚',
  '胫': '脛',
  '胶': '膠',
  '脉': '脈',
  '脍': '膾',
  '脏': '髒',
  '脐': '臍',
  '脑': '腦',
  '脓': '膿',
  '脔': '臠',
  '脚': '腳',
  '脱': '脫',
  '脲': '反',
  '脶': '腡',
  '脸': '臉',
  '腭': '齶',
  '腻': '膩',
  '腽': '膃',
  '腾': '騰',
  '膑': '臏',
  '臓': '摹',
  '臜': '臢',
  '舆': '輿',
  '舣': '艤',
  '舰': '艦',
  '舱': '艙',
  '舻': '艫',
  '艰': '艱',
  '艹': '艸',
  '艺': '藝',
  '节': '節',
  '芈': '羋',
  '芗': '薌',
  '芜': '蕪',
  '芦': '蘆',
  '苁': '蓯',
  '苇': '葦',
  '苋': '莧',
  '苌': '萇',
  '苍': '蒼',
  '苎': '苧',
  '苏': '蘇',
  '苘': '萵',
  '茎': '莖',
  '茏': '蘢',
  '茑': '蔦',
  '茔': '塋',
  '茕': '煢',
  '茧': '繭',
  '荆': '荊',
  '荚': '莢',
  '荛': '蕘',
  '荜': '蓽',
  '荞': '蕎',
  '荟': '薈',
  '荠': '薺',
  '荡': '蕩',
  '荣': '榮',
  '荤': '葷',
  '荥': '滎',
  '荦': '犖',
  '荧': '熒',
  '荨': '蕁',
  '荩': '藎',
  '荪': '蓀',
  '荫': '蔭',
  '荬': '賣',
  '荭': '葒',
  '荮': '紂',
  '药': '藥',
  '莅': '蒞',
  '莱': '萊',
  '莲': '蓮',
  '莳': '蒔',
  '莴': '萵',
  '获': '獲',
  '莸': '蕕',
  '莹': '瑩',
  '莺': '鶯',
  '莼': '蓴',
  '菭': '恰',
  '萚': '蘀',
  '萝': '蘿',
  '萤': '螢',
  '营': '營',
  '萦': '縈',
  '萧': '蕭',
  '萨': '薩',
  '葱': '蔥',
  '蒇': '蕆',
  '蒉': '蕢',
  '蒋': '蔣',
  '蒌': '蔞',
  '蓝': '藍',
  '蓟': '薊',
  '蓠': '蘺',
  '蓦': '驀',
  '蔷': '薔',
  '蔹': '蘞',
  '蔺': '藺',
  '蔼': '藹',
  '蕲': '蘄',
  '蕴': '蘊',
  '薮': '藪',
  '藁': '槁',
  '藓': '蘚',
  '蘖': '蘗',
  '虏': '虜',
  '虑': '慮',
  '虚': '虛',
  '虬': '虯',
  '虮': '蟣',
  '虽': '雖',
  '虾': '蝦',
  '虿': '蠆',
  '蚀': '蝕',
  '蚁': '蟻',
  '蚂': '螞',
  '蚕': '蠶',
  '蚬': '蜆',
  '蛊': '蠱',
  '蛎': '蠣',
  '蛏': '蟶',
  '蛮': '蠻',
  '蛰': '蟄',
  '蛱': '蛺',
  '蛲': '蟯',
  '蛳': '螄',
  '蛴': '蠐',
  '蜕': '蛻',
  '蜖': '汀',
  '蜗': '蝸',
  '蝇': '蠅',
  '蝈': '蟈',
  '蝉': '蟬',
  '蝼': '螻',
  '蝾': '蠑',
  '蝿': '蠅',
  '螀': '螿',
  '螨': '顢',
  '蟏': '蠨',
  '蟮': '蟺',
  '蠎': '蟒',
  '衅': '釁',
  '衔': '銜',
  '衤': '衣',
  '补': '補',
  '衬': '襯',
  '衮': '袞',
  '袄': '襖',
  '袅': '裊',
  '袆': '褘',
  '袭': '襲',
  '袯': '襏',
  '袴': '褲',
  '装': '裝',
  '裆': '襠',
  '裈': '褌',
  '裢': '褳',
  '裣': '襝',
  '裤': '褲',
  '裥': '襉',
  '褛': '褸',
  '褴': '襤',
  '襕': '襴',
  '覇': '霸',
  '覚': '覺',
  '覧': '覽',
  '覩': '睹',
  '见': '見',
  '观': '觀',
  '规': '規',
  '觅': '覓',
  '视': '視',
  '觇': '覘',
  '览': '覽',
  '觉': '覺',
  '觊': '覬',
  '觋': '覡',
  '觌': '覿',
  '觎': '覦',
  '觏': '覯',
  '觐': '覲',
  '觑': '覷',
  '觗': '觝',
  '觞': '觴',
  '触': '觸',
  '觯': '觶',
  '訡': '吟',
  '詟': '讋',
  '詤': '謊',
  '誀': '浴',
  '誉': '譽',
  '誊': '謄',
  '説': '說',
  '読': '讀',
  '讁': '謫',
  '讠': '言',
  '计': '計',
  '订': '訂',
  '讣': '訃',
  '认': '認',
  '讥': '譏',
  '讦': '訐',
  '讧': '訌',
  '讨': '討',
  '让': '讓',
  '讪': '訕',
  '讫': '訖',
  '训': '訓',
  '议': '議',
  '讯': '訊',
  '记': '記',
  '讱': '訒',
  '讲': '講',
  '讳': '諱',
  '讴': '謳',
  '讵': '詎',
  '讶': '訝',
  '讷': '訥',
  '许': '許',
  '讹': '訛',
  '论': '論',
  '讼': '訟',
  '讽': '諷',
  '设': '設',
  '访': '訪',
  '诀': '訣',
  '证': '證',
  '诂': '詁',
  '诃': '訶',
  '评': '評',
  '诅': '詛',
  '识': '識',
  '诇': '詗',
  '诈': '詐',
  '诉': '訴',
  '诊': '診',
  '诋': '詆',
  '诌': '謅',
  '词': '詞',
  '诎': '詘',
  '诏': '詔',
  '诐': '詖',
  '译': '譯',
  '诒': '詒',
  '诓': '誆',
  '诔': '誄',
  '试': '試',
  '诖': '詿',
  '诗': '詩',
  '诘': '詰',
  '诙': '詼',
  '诚': '誠',
  '诛': '誅',
  '诜': '詵',
  '话': '話',
  '诞': '誕',
  '诟': '詬',
  '诠': '詮',
  '诡': '詭',
  '询': '詢',
  '诣': '詣',
  '诤': '諍',
  '该': '該',
  '详': '詳',
  '诧': '詫',
  '诨': '諢',
  '诩': '詡',
  '诪': '譸',
  '诫': '誡',
  '诬': '誣',
  '语': '語',
  '诮': '誚',
  '误': '誤',
  '诰': '誥',
  '诱': '誘',
  '诲': '誨',
  '诳': '誑',
  '说': '說',
  '诵': '誦',
  '诶': '誒',
  '请': '請',
  '诸': '諸',
  '诹': '諏',
  '诺': '諾',
  '读': '讀',
  '诼': '諑',
  '诽': '誹',
  '课': '課',
  '诿': '諉',
  '谀': '諛',
  '谁': '誰',
  '谂': '諗',
  '调': '調',
  '谄': '諂',
  '谅': '諒',
  '谆': '諄',
  '谇': '誶',
  '谈': '談',
  '谊': '誼',
  '谋': '謀',
  '谌': '諶',
  '谍': '諜',
  '谎': '謊',
  '谏': '諫',
  '谐': '諧',
  '谑': '謔',
  '谒': '謁',
  '谓': '謂',
  '谔': '諤',
  '谕': '諭',
  '谖': '諼',
  '谗': '讒',
  '谘': '諮',
  '谙': '諳',
  '谚': '諺',
  '谛': '諦',
  '谜': '謎',
  '谝': '諞',
  '谞': '住',
  '谟': '謨',
  '谠': '讜',
  '谡': '謖',
  '谢': '謝',
  '谣': '謠',
  '谤': '謗',
  '谥': '謚',
  '谦': '謙',
  '谧': '謐',
  '谨': '謹',
  '谩': '謾',
  '谪': '謫',
  '谫': '譾',
  '谬': '謬',
  '谭': '譚',
  '谮': '譖',
  '谯': '譙',
  '谰': '讕',
  '谱': '譜',
  '谲': '譎',
  '谳': '讞',
  '谴': '譴',
  '谵': '譫',
  '谶': '讖',
  '豮': '豶',
  '貭': '亍',
  '貮': '貳',
  '賍': '贓',
  '賎': '賤',
  '賖': '賒',
  '賘': '髒',
  '贋': '贗',
  '贘': '償',
  '贝': '貝',
  '贞': '貞',
  '负': '負',
  '贡': '貢',
  '财': '財',
  '责': '責',
  '贤': '賢',
  '败': '敗',
  '账': '賬',
  '货': '貨',
  '质': '質',
  '贩': '販',
  '贪': '貪',
  '贫': '貧',
  '贬': '貶',
  '购': '購',
  '贮': '貯',
  '贯': '貫',
  '贰': '貳',
  '贱': '賤',
  '贲': '賁',
  '贳': '貰',
  '贴': '貼',
  '贵': '貴',
  '贶': '貺',
  '贷': '貸',
  '贸': '貿',
  '费': '費',
  '贺': '賀',
  '贻': '貽',
  '贼': '賊',
  '贽': '贄',
  '贾': '賈',
  '贿': '賄',
  '赀': '貲',
  '赁': '賃',
  '赂': '賂',
  '赃': '贓',
  '资': '資',
  '赅': '賅',
  '赆': '贐',
  '赇': '賕',
  '赈': '賑',
  '赉': '賚',
  '赊': '賒',
  '赋': '賦',
  '赌': '賭',
  '赍': '齎',
  '赎': '贖',
  '赏': '賞',
  '赐': '賜',
  '赑': '贔',
  '赒': '賙',
  '赓': '賡',
  '赔': '賠',
  '赖': '賴',
  '赗': '賵',
  '赘': '贅',
  '赙': '賻',
  '赚': '賺',
  '赛': '賽',
  '赜': '賾',
  '赝': '贗',
  '赞': '贊',
  '赟': '贇',
  '赠': '贈',
  '赡': '贍',
  '赢': '贏',
  '赣': '贛',
  '赪': '赬',
  '赵': '趙',
  '趋': '趨',
  '趱': '趲',
  '趸': '躉',
  '跃': '躍',
  '跄': '蹌',
  '跞': '躒',
  '践': '踐',
  '跶': '躂',
  '跷': '蹺',
  '跸': '蹕',
  '跹': '躚',
  '跻': '躋',
  '踌': '躊',
  '踪': '蹤',
  '踬': '躓',
  '踯': '躑',
  '蹑': '躡',
  '蹒': '蹣',
  '蹰': '躕',
  '蹿': '躥',
  '躏': '躪',
  '躜': '躦',
  '躯': '軀',
  '车': '車',
  '轧': '軋',
  '轨': '軌',
  '轩': '軒',
  '轪': '軑',
  '轫': '軔',
  '转': '轉',
  '轭': '軛',
  '轮': '輪',
  '软': '軟',
  '轰': '轟',
  '轱': '古',
  '轲': '軻',
  '轳': '轤',
  '轴': '軸',
  '轵': '軹',
  '轶': '軼',
  '轷': '乎',
  '轸': '軫',
  '轹': '轢',
  '轺': '軺',
  '轻': '輕',
  '轼': '軾',
  '载': '載',
  '轾': '輊',
  '轿': '轎',
  '辀': '輈',
  '辁': '輇',
  '辂': '輅',
  '较': '較',
  '辄': '輒',
  '辅': '輔',
  '辆': '輛',
  '辇': '輦',
  '辈': '輩',
  '辉': '輝',
  '辊': '輥',
  '辋': '輞',
  '辌': '輬',
  '辍': '輟',
  '辎': '輜',
  '辏': '輳',
  '辐': '輻',
  '辑': '輯',
  '辒': '轀',
  '输': '輸',
  '辔': '轡',
  '辕': '轅',
  '辖': '轄',
  '辗': '輾',
  '辘': '轆',
  '辙': '轍',
  '辚': '轔',
  '辞': '辭',
  '辩': '辯',
  '辫': '辮',
  '辬': '辨',
  '边': '邊',
  '辽': '遼',
  '达': '達',
  '迁': '遷',
  '过': '過',
  '迈': '邁',
  '运': '運',
  '还': '還',
  '这': '這',
  '进': '進',
  '远': '遠',
  '违': '違',
  '连': '連',
  '迟': '遲',
  '迩': '邇',
  '迳': '逕',
  '迹': '跡',
  '选': '選',
  '逊': '遜',
  '递': '遞',
  '逦': '邐',
  '逻': '邏',
  '遗': '遺',
  '遥': '遙',
  '邓': '鄧',
  '邝': '鄺',
  '邬': '鄔',
  '邮': '郵',
  '邹': '鄒',
  '邺': '鄴',
  '邻': '鄰',
  '郄': '卻',
  '郏': '郟',
  '郐': '鄶',
  '郑': '鄭',
  '郓': '鄆',
  '郦': '酈',
  '郧': '鄖',
  '郷': '鄉',
  '郸': '鄲',
  '鄊': '鄉',
  '鄕': '鄉',
  '鄷': '酆',
  '酝': '醞',
  '酦': '醱',
  '酱': '醬',
  '酽': '釅',
  '酾': '釃',
  '酿': '釀',
  '释': '釋',
  '釡': '斧',
  '鉴': '鑒',
  '銮': '鑾',
  '錾': '鏨',
  '鎻': '鎖',
  '钅': '金',
  '钆': '釓',
  '钇': '釔',
  '针': '針',
  '钉': '釘',
  '钊': '釗',
  '钋': '釙',
  '钌': '釕',
  '钍': '釷',
  '钏': '釧',
  '钐': '釤',
  '钑': '鈒',
  '钒': '釩',
  '钓': '釣',
  '钔': '鍆',
  '钕': '釹',
  '钖': '鍚',
  '钗': '釵',
  '钘': '鈃',
  '钙': '鈣',
  '钚': '鈽',
  '钛': '鈦',
  '钜': '鉅',
  '钝': '鈍',
  '钞': '鈔',
  '钟': '鐘',
  '钠': '鈉',
  '钡': '鋇',
  '钢': '鋼',
  '钣': '鈑',
  '钤': '鈐',
  '钥': '鑰',
  '钦': '欽',
  '钧': '鈞',
  '钨': '鎢',
  '钩': '鉤',
  '钪': '鈧',
  '钫': '鈁',
  '钬': '鈥',
  '钮': '鈕',
  '钯': '鈀',
  '钰': '鈺',
  '钱': '錢',
  '钲': '鉦',
  '钳': '鉗',
  '钴': '鈷',
  '钵': '缽',
  '钶': '鈳',
  '钸': '鈽',
  '钹': '鈸',
  '钺': '鉞',
  '钻': '鑽',
  '钼': '鉬',
  '钽': '鉭',
  '钾': '鉀',
  '钿': '鈿',
  '铀': '鈾',
  '铁': '鐵',
  '铂': '鉑',
  '铃': '鈴',
  '铄': '鑠',
  '铅': '鉛',
  '铆': '鉚',
  '铈': '鈰',
  '铉': '鉉',
  '铊': '鉈',
  '铋': '鉍',
  '铌': '鈮',
  '铍': '鈹',
  '铎': '鐸',
  '铏': '鉶',
  '铐': '銬',
  '铑': '銠',
  '铒': '鉺',
  '铓': '鋩',
  '铔': '錏',
  '铕': '銪',
  '铖': '鋮',
  '铗': '鋏',
  '铘': '邪',
  '铙': '鐃',
  '铚': '銍',
  '铛': '鐺',
  '铜': '銅',
  '铝': '鋁',
  '铞': '吊',
  '铟': '銦',
  '铠': '鎧',
  '铡': '鍘',
  '铢': '銖',
  '铣': '銑',
  '铤': '鋌',
  '铥': '銩',
  '铦': '銛',
  '铧': '鏵',
  '铨': '銓',
  '铩': '鎩',
  '铪': '鉿',
  '铫': '銚',
  '铬': '鉻',
  '铭': '銘',
  '铮': '錚',
  '铯': '銫',
  '铰': '鉸',
  '铱': '銥',
  '铲': '鏟',
  '铳': '銃',
  '铴': '鐋',
  '铵': '銨',
  '银': '銀',
  '铷': '銣',
  '铸': '鑄',
  '铹': '鐒',
  '铺': '鋪',
  '铻': '鋙',
  '铼': '錸',
  '铽': '鋱',
  '链': '鏈',
  '铿': '鏗',
  '销': '銷',
  '锁': '鎖',
  '锂': '鋰',
  '锃': '呈',
  '锄': '鋤',
  '锅': '鍋',
  '锆': '鋯',
  '锇': '鋨',
  '锈': '鏽',
  '锉': '銼',
  '锊': '鋝',
  '锋': '鋒',
  '锌': '鋅',
  '锍': '琉',
  '锎': '鉲',
  '锏': '閒',
  '锐': '銳',
  '锑': '銻',
  '锒': '鋃',
  '锓': '鋟',
  '锔': '鋦',
  '锕': '錒',
  '锖': '錆',
  '锗': '鍺',
  '锘': '若',
  '错': '錯',
  '锚': '錨',
  '锛': '錛',
  '锜': '錡',
  '锝': '鎝',
  '锞': '錁',
  '锟': '錕',
  '锠': '琛',
  '锡': '錫',
  '锢': '錮',
  '锣': '鑼',
  '锤': '錘',
  '锥': '錐',
  '锦': '錦',
  '锧': '鑕',
  '锨': '杴',
  '锪': '忽',
  '锫': '培',
  '锬': '錟',
  '锭': '錠',
  '键': '鍵',
  '锯': '鋸',
  '锰': '錳',
  '锱': '錙',
  '锲': '鍥',
  '锴': '鍇',
  '锵': '鏘',
  '锶': '鍶',
  '锷': '鍔',
  '锸': '鍤',
  '锹': '鍬',
  '锺': '鍾',
  '锻': '鍛',
  '锼': '鎪',
  '锽': '鍠',
  '锾': '鍰',
  '锿': '鑀',
  '镀': '鍍',
  '镁': '鎂',
  '镂': '鏤',
  '镃': '鎡',
  '镄': '鐨',
  '镅': '鋂',
  '镆': '鏌',
  '镇': '鎮',
  '镈': '鎛',
  '镉': '鎘',
  '镊': '鑷',
  '镋': '钂',
  '镌': '鐫',
  '镍': '鎳',
  '镎': '拿',
  '镏': '鎦',
  '镐': '鎬',
  '镑': '鎊',
  '镒': '鎰',
  '镓': '鎵',
  '镔': '鑌',
  '镕': '鎔',
  '镖': '鏢',
  '镗': '鏜',
  '镘': '鏝',
  '镙': '鏍',
  '镛': '鏞',
  '镜': '鏡',
  '镝': '鏑',
  '镞': '鏃',
  '镟': '鏇',
  '镠': '鏐',
  '镡': '鐔',
  '镢': '钁',
  '镣': '鐐',
  '镤': '鏷',
  '镥': '魯',
  '镧': '鑭',
  '镨': '鐠',
  '镩': '串',
  '镪': '鏹',
  '镫': '鐙',
  '镬': '鑊',
  '镭': '鐳',
  '镮': '鐶',
  '镯': '鐲',
  '镰': '鐮',
  '镱': '鐿',
  '镲': '察',
  '镳': '鑣',
  '镴': '鑞',
  '镵': '鑱',
  '镶': '鑲',
  '长': '長',
  '閲': '閱',
  '门': '門',
  '闩': '閂',
  '闪': '閃',
  '闫': '閆',
  '闬': '閈',
  '闭': '閉',
  '问': '問',
  '闯': '闖',
  '闰': '閏',
  '闱': '闈',
  '闲': '閒',
  '闳': '閎',
  '间': '間',
  '闵': '閔',
  '闶': '閌',
  '闷': '悶',
  '闸': '閘',
  '闹': '鬧',
  '闺': '閨',
  '闻': '聞',
  '闼': '闥',
  '闽': '閩',
  '闾': '閭',
  '闿': '闓',
  '阀': '閥',
  '阁': '閣',
  '阂': '閡',
  '阃': '閫',
  '阄': '鬮',
  '阅': '閱',
  '阆': '閬',
  '阇': '闍',
  '阈': '閾',
  '阉': '閹',
  '阊': '閶',
  '阋': '鬩',
  '阌': '閿',
  '阍': '閽',
  '阎': '閻',
  '阏': '閼',
  '阐': '闡',
  '阑': '闌',
  '阒': '闃',
  '阓': '闠',
  '阔': '闊',
  '阕': '闋',
  '阖': '闔',
  '阗': '闐',
  '阘': '闒',
  '阙': '闕',
  '阚': '闞',
  '阛': '闤',
  '阝': '阜',
  '队': '隊',
  '阳': '陽',
  '阴': '陰',
  '阵': '陣',
  '阶': '階',
  '际': '際',
  '陆': '陸',
  '陇': '隴',
  '陈': '陳',
  '陉': '陘',
  '陕': '陝',
  '陧': '隉',
  '陨': '隕',
  '险': '險',
  '隂': '陰',
  '隌': '暗',
  '随': '隨',
  '隐': '隱',
  '隠': '隱',
  '隷': '隸',
  '隽': '雋',
  '难': '難',
  '雏': '雛',
  '雠': '讎',
  '雳': '靂',
  '雾': '霧',
  '霁': '霽',
  '霊': '靈',
  '霭': '靄',
  '靓': '靚',
  '静': '靜',
  '靥': '靨',
  '鞑': '韃',
  '鞒': '轎',
  '鞯': '韉',
  '鞲': '韝',
  '鞽': '轎',
  '韦': '韋',
  '韧': '韌',
  '韨': '韍',
  '韩': '韓',
  '韪': '韙',
  '韫': '韞',
  '韬': '韜',
  '韯': '籤',
  '韲': '齋',
  '韵': '韻',
  '顋': '腮',
  '顔': '顏',
  '顕': '顯',
  '页': '頁',
  '顶': '頂',
  '顷': '頃',
  '顸': '頇',
  '项': '項',
  '顺': '順',
  '须': '須',
  '顼': '頊',
  '顽': '頑',
  '顾': '顧',
  '顿': '頓',
  '颀': '頎',
  '颁': '頒',
  '颂': '頌',
  '颃': '頏',
  '预': '預',
  '颅': '顱',
  '领': '領',
  '颇': '頗',
  '颈': '頸',
  '颉': '頡',
  '颊': '頰',
  '颋': '頲',
  '颌': '頜',
  '颍': '潁',
  '颎': '熲',
  '颏': '頦',
  '颐': '頤',
  '频': '頻',
  '颓': '頹',
  '颔': '頷',
  '颕': '穎',
  '颖': '穎',
  '颗': '顆',
  '题': '題',
  '颙': '顒',
  '颚': '顎',
  '颛': '顓',
  '颜': '顏',
  '额': '額',
  '颞': '顳',
  '颟': '顢',
  '颠': '顛',
  '颡': '顙',
  '颢': '顥',
  '颣': '纇',
  '颤': '顫',
  '颥': '須',
  '颦': '顰',
  '颧': '顴',
  '颷': '飆',
  '风': '風',
  '飏': '颺',
  '飐': '颭',
  '飑': '颮',
  '飒': '颯',
  '飓': '颶',
  '飔': '颸',
  '飕': '颼',
  '飖': '颻',
  '飗': '飀',
  '飘': '飄',
  '飙': '飆',
  '飚': '飆',
  '飞': '飛',
  '飨': '饗',
  '飬': '養',
  '飮': '飲',
  '飱': '餐',
  '餍': '饜',
  '饣': '食',
  '饤': '飣',
  '饥': '飢',
  '饦': '飥',
  '饧': '餳',
  '饨': '飩',
  '饩': '餼',
  '饪': '飪',
  '饫': '飫',
  '饬': '飭',
  '饭': '飯',
  '饮': '飲',
  '饯': '餞',
  '饰': '飾',
  '饱': '飽',
  '饲': '飼',
  '饴': '飴',
  '饵': '餌',
  '饶': '饒',
  '饷': '餉',
  '饺': '餃',
  '饼': '餅',
  '饽': '餑',
  '饾': '餖',
  '饿': '餓',
  '馀': '餘',
  '馁': '餒',
  '馂': '餕',
  '馄': '餛',
  '馅': '餡',
  '馆': '館',
  '馇': '查',
  '馈': '饋',
  '馉': '稹',
  '馊': '餿',
  '馋': '饞',
  '馌': '饁',
  '馍': '饃',
  '馎': '餺',
  '馏': '餾',
  '馐': '饈',
  '馑': '饉',
  '馒': '饅',
  '馓': '饊',
  '馔': '饌',
  '馕': '囊',
  '马': '馬',
  '驭': '馭',
  '驮': '馱',
  '驯': '馴',
  '驰': '馳',
  '驱': '驅',
  '驲': '馹',
  '驳': '駁',
  '驴': '驢',
  '驵': '駔',
  '驶': '駛',
  '驷': '駟',
  '驸': '駙',
  '驹': '駒',
  '驺': '騶',
  '驻': '駐',
  '驼': '駝',
  '驽': '駑',
  '驾': '駕',
  '驿': '驛',
  '骀': '駘',
  '骁': '驍',
  '骂': '罵',
  '骃': '駰',
  '骄': '驕',
  '骅': '驊',
  '骆': '駱',
  '骇': '駭',
  '骈': '駢',
  '骊': '驪',
  '骋': '騁',
  '验': '驗',
  '骍': '騂',
  '骎': '駸',
  '骏': '駿',
  '骐': '騏',
  '骑': '騎',
  '骒': '騍',
  '骓': '騅',
  '骕': '驌',
  '骖': '驂',
  '骗': '騙',
  '骘': '騭',
  '骙': '騤',
  '骚': '騷',
  '骛': '騖',
  '骜': '驁',
  '骝': '騮',
  '骞': '騫',
  '骟': '騸',
  '骠': '驃',
  '骡': '騾',
  '骢': '驄',
  '骣': '驏',
  '骤': '驟',
  '骥': '驥',
  '骦': '驦',
  '骧': '驤',
  '髅': '髏',
  '髋': '髖',
  '髌': '髕',
  '鬓': '鬢',
  '魇': '魘',
  '魉': '魎',
  '鱼': '魚',
  '鱿': '魷',
  '鲀': '魨',
  '鲁': '魯',
  '鲂': '魴',
  '鲅': '鱍',
  '鲆': '平',
  '鲇': '占',
  '鲈': '鱸',
  '鲊': '鮓',
  '鲋': '鮒',
  '鲍': '鮑',
  '鲎': '鱟',
  '鲐': '鮐',
  '鲑': '鮭',
  '鲒': '鮚',
  '鲔': '鮪',
  '鲕': '鮞',
  '鲖': '鮦',
  '鲙': '鱠',
  '鲚': '鱭',
  '鲛': '鮫',
  '鲜': '鮮',
  '鲞': '鯗',
  '鲟': '鱘',
  '鲠': '鯁',
  '鲡': '鱺',
  '鲢': '鰱',
  '鲣': '鰹',
  '鲤': '鯉',
  '鲥': '鰣',
  '鲦': '鰷',
  '鲧': '鯀',
  '鲨': '鯊',
  '鲩': '鯇',
  '鲫': '鯽',
  '鲭': '鯖',
  '鲮': '鯪',
  '鲰': '鯫',
  '鲱': '鯡',
  '鲲': '鯤',
  '鲳': '鯧',
  '鲴': '固',
  '鲵': '鯢',
  '鲶': '鯰',
  '鲷': '鯛',
  '鲸': '鯨',
  '鲺': '虱',
  '鲻': '鯔',
  '鲼': '賁',
  '鲽': '鰈',
  '鲿': '鱨',
  '鳀': '鯷',
  '鳃': '鰓',
  '鳄': '鱷',
  '鳅': '鰍',
  '鳆': '鰒',
  '鳇': '鰉',
  '鳊': '扁',
  '鳋': '蚤',
  '鳌': '鰲',
  '鳍': '鰭',
  '鳏': '鰥',
  '鳐': '鰩',
  '鳒': '鰜',
  '鳔': '鰾',
  '鳕': '鱈',
  '鳖': '鱉',
  '鳗': '鰻',
  '鳘': '鱉',
  '鳙': '庸',
  '鳛': '鰼',
  '鳜': '鱖',
  '鳝': '鱔',
  '鳞': '鱗',
  '鳟': '鱒',
  '鳡': '鰲',
  '鳢': '鱧',
  '鳣': '鱣',
  '鸟': '鳥',
  '鸠': '鳩',
  '鸡': '雞',
  '鸢': '鳶',
  '鸣': '鳴',
  '鸤': '鳲',
  '鸥': '鷗',
  '鸦': '鴉',
  '鸧': '鶬',
  '鸨': '鴇',
  '鸩': '鴆',
  '鸪': '鴣',
  '鸬': '鸕',
  '鸭': '鴨',
  '鸮': '鴞',
  '鸯': '鴦',
  '鸰': '鴒',
  '鸱': '鴟',
  '鸲': '鴝',
  '鸳': '鴛',
  '鸵': '鴕',
  '鸶': '鷥',
  '鸷': '鷙',
  '鸹': '鴰',
  '鸺': '鵂',
  '鸼': '鵃',
  '鸽': '鴿',
  '鸾': '鸞',
  '鸿': '鴻',
  '鹁': '鵓',
  '鹂': '鸝',
  '鹃': '鵑',
  '鹄': '鵠',
  '鹅': '鵝',
  '鹆': '鵒',
  '鹇': '鷳',
  '鹈': '鵜',
  '鹉': '鵡',
  '鹊': '鵲',
  '鹋': '苗',
  '鹌': '鵪',
  '鹎': '鵯',
  '鹏': '鵬',
  '鹑': '鶉',
  '鹒': '鶊',
  '鹓': '鵷',
  '鹔': '鷫',
  '鹕': '鶘',
  '鹖': '鶡',
  '鹗': '鶚',
  '鹘': '鶻',
  '鹙': '鶖',
  '鹚': '鶿',
  '鹛': '眉',
  '鹜': '鶩',
  '鹝': '鷊',
  '鹞': '鷂',
  '鹠': '鶹',
  '鹡': '鶺',
  '鹢': '鷁',
  '鹣': '鶼',
  '鹤': '鶴',
  '鹥': '鷖',
  '鹦': '鸚',
  '鹧': '鷓',
  '鹨': '鷚',
  '鹩': '鷯',
  '鹪': '鷦',
  '鹫': '鷲',
  '鹬': '鷸',
  '鹭': '鷺',
  '鹯': '鸇',
  '鹰': '鷹',
  '鹱': '獲',
  '鹲': '鸏',
  '鹳': '鸛',
  '鹾': '鹺',
  '麦': '麥',
  '麸': '麩',
  '麹': '麴',
  '麺': '麵',
  '麽': '麼',
  '黄': '黃',
  '黉': '黌',
  '黒': '黑',
  '黙': '默',
  '黡': '黶',
  '黩': '黷',
  '黪': '黲',
  '黾': '黽',
  '鼋': '黿',
  '鼍': '鼉',
  '鼗': '鞀',
  '鼹': '鼴',
  '齄': '皻',
  '齐': '齊',
  '齑': '齏',
  '齿': '齒',
  '龀': '齔',
  '龁': '齕',
  '龂': '齗',
  '龃': '齟',
  '龄': '齡',
  '龅': '齙',
  '龆': '齠',
  '龇': '齜',
  '龈': '齦',
  '龉': '齬',
  '龊': '齪',
  '龋': '齲',
  '龌': '齷',
  '龙': '龍',
  '龚': '龔',
  '龛': '龕',
  '龟': '龜'
};

function chsToChz(text) {
  text = String(text);
  const res = [];
  for (let i = 0; i < text.length; i += 1) {
    res.push(charMap[text[i]] || text[i]);
  }
  return res.join('');
}

/***/ }),
/* 21 */,
/* 22 */,
/* 23 */,
/* 24 */,
/* 25 */,
/* 26 */,
/* 27 */,
/* 28 */,
/* 29 */,
/* 30 */,
/* 31 */,
/* 32 */,
/* 33 */,
/* 34 */,
/* 35 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_promise_more__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__audio_manager__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_src_helpers_chs_to_chz__ = __webpack_require__(20);




const AUDIO = new __WEBPACK_IMPORTED_MODULE_2__audio_manager__["a" /* default */]();

__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].server();

__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].listen((data, sender, sendResponse) => {
  switch (data.msg) {
    case 'OPEN_URL':
      return createTab(data, sender, sendResponse);
    case 'AUDIO_PLAY':
      return playAudio(data, sender, sendResponse);
    case 'FETCH_DICT_RESULT':
      return fetchDictResult(data, sender, sendResponse);
    case 'PRELOAD_SELECTION':
      return preloadSelection(data, sender, sendResponse);
  }
});

function createTab(data, sender, sendResponse) {
  Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["b" /* openURL */])(data.escape ? data.url.replace('%s', this.text).replace('%z', Object(__WEBPACK_IMPORTED_MODULE_3_src_helpers_chs_to_chz__["a" /* default */])(this.text)) : data.url);
  sendResponse();
}

function playAudio(data, sender, sendResponse) {
  AUDIO.load(data.src);
  Promise.race([Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_promise_more__["b" /* promiseTimer */])(4000), new Promise(resolve => AUDIO.listen('ended', resolve))]).then(sendResponse);
  AUDIO.play();
  return true;
}

function fetchDictResult(data, sender, sendResponse) {
  const search = __webpack_require__(37)("./" + data.dict + '/engine.js').default;
  if (!search) {
    sendResponse({ error: 'Missing Dictionary!' });
    return;
  }

  __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["c" /* storage */].sync.get('config', ({ config }) => {
    search(data.text, config, { AUDIO }).then(result => sendResponse({ result, dict: data.dict })).catch(error => sendResponse({ error, dict: data.dict }));
  });

  return true;
}

function preloadSelection(data, sender, sendResponse) {
  chrome.tabs.query({ active: true, currentWindow: true }, tabs => {
    if (tabs.length > 0) {
      __WEBPACK_IMPORTED_MODULE_0_src_helpers_chrome_api__["a" /* message */].send(tabs[0].id, { msg: '__PRELOAD_SELECTION__' }, text => {
        sendResponse(text || '');
      });
    } else {
      sendResponse('');
    }
  });
  return true;
}

/***/ }),
/* 36 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

class AudioManager {
  constructor() {
    this.audio = new Audio();
  }

  load(src) {
    this.audio.pause();
    this.audio.currentTime = 0;
    this.audio.src = '';
    this.audio = new Audio(src);
  }

  play(src) {
    if (src) {
      this.load(src);
    }

    this.audio.play().catch(() => {});
  }

  listen(...args) {
    return this.audio.addEventListener(...args);
  }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = AudioManager;


/***/ }),
/* 37 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./bing/engine.js": 38,
	"./business/engine.js": 39,
	"./cobuild/engine.js": 40,
	"./dictcn/engine.js": 41,
	"./etymonline/engine.js": 42,
	"./eudic/engine.js": 43,
	"./google/engine.js": 44,
	"./guoyu/engine.js": 45,
	"./howjsay/engine.js": 46,
	"./liangan/engine.js": 47,
	"./macmillan/engine.js": 48,
	"./urban/engine.js": 49,
	"./vocabulary/engine.js": 50,
	"./wordreference/engine.js": 51,
	"./zdic/engine.js": 52
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 37;

/***/ }),
/* 38 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);


function search(text, config, { AUDIO }) {
  const DICT_LINK = 'https://cn.bing.com/dict/clientsearch?mkt=zh-CN&setLang=zh&form=BDVEHC&ClientVer=BDDTV3.5.1.4320&q=';

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])(DICT_LINK + text).then(doc => handleDom(doc, config)).then(result => {
    if (config.autopron.en.dict === 'bing') {
      setTimeout(() => {
        playAudio(result, config, AUDIO);
      }, 0);
    }
    return result;
  });
}

function handleDom(doc, config) {
  const options = config.dicts.all.bing.options;

  if (doc.querySelector('.client_def_hd_hd')) {
    return handleLexResult(doc, options);
  }

  if (doc.querySelector('.client_trans_head')) {
    return handleMachineResult(doc, options);
  }

  if (options.related) {
    if (doc.querySelector('.client_do_you_mean_title_bar')) {
      return handleRelatedResult(doc, config.dicts.all.bing);
    }
  }

  return Promise.reject('no result');
}

function handleLexResult(doc, options) {
  let result = {
    type: 'lex',
    title: getText(doc, '.client_def_hd_hd')
  };

  if (options.phsym) {
    let $prons = Array.from(doc.querySelectorAll('.client_def_hd_pn_list'));
    if ($prons.length > 0) {
      result.phsym = $prons.map(el => {
        let pron = '';
        let $audio = el.querySelector('.client_aud_o');
        if ($audio) {
          pron = (($audio.getAttribute('onclick') || '').match(/https.*\.mp3/) || [''])[0];
        }
        return {
          lang: getText(el, '.client_def_hd_pn'),
          pron
        };
      });
    }
  }

  if (options.cdef) {
    let $container = doc.querySelector('.client_def_container');
    if ($container) {
      let $defs = Array.from($container.querySelectorAll('.client_def_bar'));
      if ($defs.length > 0) {
        result.cdef = $defs.map(el => ({
          'pos': getText(el, '.client_def_title_bar'),
          'def': getText(el, '.client_def_list')
        }));
      }
    }
  }

  if (options.tense) {
    let $infs = Array.from(doc.querySelectorAll('.client_word_change_word'));
    if ($infs.length > 0) {
      result.infs = $infs.map(el => el.innerText.trim());
    }
  }

  if (options.sentence > 0) {
    let $sens = Array.from(doc.querySelectorAll('.client_sentence_list'));
    if ($sens.length > 0) {
      result.sentences = $sens.map(el => {
        let mp3 = '';
        let $audio = el.querySelector('.client_aud_o');
        if ($audio) {
          mp3 = (($audio.getAttribute('onclick') || '').match(/https.*\.mp3/) || [''])[0];
        }
        return {
          en: getText(el, '.client_sen_en'),
          chs: getText(el, '.client_sen_cn'),
          source: getText(el, '.client_sentence_list_link'),
          mp3
        };
      }).slice(0, options.sentence);
    }
  }

  if (Object.keys(result).length > 0) {
    return result;
  }
  return Promise.reject('no result');
}

function handleMachineResult(doc, options) {
  return {
    type: 'machine',
    mt: getText(doc, '.client_sen_cn')
  };
}

function handleRelatedResult(doc, bingConfig) {
  const result = {
    type: 'related',
    title: getText(doc, '.client_do_you_mean_title_bar'),
    defs: []
  };

  doc.querySelectorAll('.client_do_you_mean_area').forEach($area => {
    const $defsList = $area.querySelectorAll('.client_do_you_mean_list');
    if ($defsList.length > 0) {
      result.defs.push({
        title: getText($area, '.client_do_you_mean_title'),
        meanings: Array.from($defsList).map($list => {
          const word = getText($list, '.client_do_you_mean_list_word');
          return {
            href: bingConfig.page.replace('%s', word),
            word,
            def: getText($list, '.client_do_you_mean_list_def')
          };
        })
      });
    }
  });

  return result;
}

function getText(el, childSelector) {
  var child = el.querySelector(childSelector);
  if (child) {
    return child.innerText.trim();
  }
  return '';
}

function playAudio(result, config, AUDIO) {
  if (result.phsym) {
    const accentTester = new RegExp(config.autopron.en.accent, 'i');
    const isMatched = result.phsym.some(({ lang, pron }) => {
      if (accentTester.test(lang) && pron) {
        AUDIO.play(pron);
        return true;
      }
    });
    if (!isMatched) {
      result.phsym.some(({ pron }) => {
        if (pron) {
          AUDIO.play(pron);
          return true;
        }
      });
    }
  }
}

/***/ }),
/* 39 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__ = __webpack_require__(11);



function search(text, config) {
  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.ldoceonline.com/dictionary/' + text.replace(/[^A-Za-z0-9]+/g, '-')).then(handleDom).then(null, () => trySuggestion(text));
}

function handleDom(doc) {
  let $entry = doc.querySelector('.bussdictEntry');
  if (!$entry) {
    return Promise.reject('no result');
  }
  return Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])($entry).innerHTML;
}

function trySuggestion(text) {
  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.ldoceonline.com/search/?q=' + text).then(doc => {
    let li = doc.querySelector('.searches li');
    if (li && li.innerText) {
      return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.ldoceonline.com/dictionary/' + li.innerText).then(doc => handleDom(doc));
    }
    return Promise.reject('no result');
  });
}

/***/ }),
/* 40 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__ = __webpack_require__(11);



function search(text, config) {
  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.iciba.com/' + text).then(handleDom);
}

function handleDom(doc) {
  let result = {};

  let $title = doc.querySelector('.keyword');
  if ($title) {
    result.title = $title.innerText.trim();
  }

  let $level = doc.querySelector('.base-level');
  if ($level) {
    result.level = $level.innerText.trim();
  }

  let $star = doc.querySelector('.word-rate [class^="star"]');
  if ($star) {
    let star = Number($star.className[$star.className.length - 1]);
    if (!isNaN(star)) {
      result.star = star;
    }
  }

  let $pron = doc.querySelector('.base-speak');
  if ($pron) {
    result.prons = Array.from($pron.children).map(el => ({
      phsym: el.innerText.trim(),
      audio: (/http\S+.mp3/.exec(el.innerText) || [''])[0]
    }));
  }

  let $article = Array.from(doc.querySelectorAll('.info-article')).find(x => /柯林斯高阶英汉双解学习词典/.test(x.innerText));
  if ($article) {
    result.defs = Array.from($article.querySelectorAll('.prep-order')).map(x => Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])(x).innerHTML);
  }

  if (Object.keys(result).length > 0) {
    return result;
  }
  return Promise.reject('no result');
}

/***/ }),
/* 41 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);

const mp3link = 'http://audio.dict.cn/';

function search(text, config, { AUDIO }) {
  const options = config.dicts.all.dictcn.options;

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://dict.cn/' + text).then(doc => handleDom(doc, options)).then(result => {
    if (config.autopron.en.dict === 'dictcn') {
      setTimeout(() => {
        playAudio(result, config, AUDIO);
      }, 0);
    }
    return result;
  });
}

function handleDom(doc, options) {
  let result = {};

  let $title = doc.querySelector('.keyword');
  if ($title) {
    result.title = $title.innerText;
  }

  let $level = doc.querySelector('.level-title');
  if ($level) {
    result.level = $level.getAttribute('level');
  }

  let $star = doc.querySelector('[class^="level_"]');
  if ($star) {
    result.star = Number($star.className.replace('level_', ''));
  }

  let $phonetic = doc.querySelector('.phonetic');
  if ($phonetic) {
    result.prons = Array.from($phonetic.children).map(el => ({
      phsym: el.innerText.replace(/\s+/gm, ' ').trim(),
      audio: Array.from(el.querySelectorAll('.sound')).map(x => mp3link + x.getAttribute('naudio'))
    }));
  }

  if (options.chart) {
    try {
      result.chart = JSON.parse(decodeURIComponent(doc.getElementById('dict-chart-basic').getAttribute('data')));
    } catch (e) {}
  }

  if (options.etym) {
    let $etym = doc.querySelector('.etm');
    if ($etym && $etym.innerText) {
      result.etym = $etym.innerText.split('\n');
    }
  }

  if (Object.keys(result).length <= 1) {
    return Promise.reject('no result');
  }

  return result;
}

function playAudio(result, config, AUDIO) {
  if (result.prons) {
    const accentMap = {
      us: '美',
      uk: '英'
    };
    const accentTester = new RegExp(accentMap[config.autopron.en.accent], 'i');
    const isMatched = result.prons.some(({ phsym, audio }) => {
      if (accentTester.test(phsym) && audio && audio[0]) {
        AUDIO.play(audio[0]);
        return true;
      }
    });

    if (!isMatched) {
      result.prons.some(({ audio }) => {
        if (audio && audio[0]) {
          AUDIO.play(audio[0]);
          return true;
        }
      });
    }
  }
}

/***/ }),
/* 42 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__ = __webpack_require__(11);



function search(text, config) {
  const options = config.dicts.all.etymonline.options;

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.etymonline.com/search?q=' + text).then(doc => handleDom(doc, options));
}

function handleDom(doc, { resultnum }) {
  const result = Array.from(doc.querySelectorAll('[class^="word--"]')).slice(0, resultnum).map(el => {
    let href = el.getAttribute('href') || '';
    if (href[0] === '/') {
      href = 'http://www.etymonline.com' + href;
    }

    let title;
    let $title = el.querySelector('[class^="word__name--"]');
    if ($title) {
      title = $title.innerText.trim();
    }

    let def = '';
    let $def = el.querySelector('[class^="word__defination--"]>object');
    if ($def) {
      $def.querySelectorAll('.crossreference').forEach($cf => {
        let word = $cf.innerText.trim();
        $cf.innerHTML = `<a href="http://www.etymonline.com/word/${word}" target="_blank">${word}</a>`;
      });
      const $cleanDef = doc.createElement('div');
      $cleanDef.innerHTML = $def.innerHTML;
      def = Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])($cleanDef).innerHTML;
    }

    if (title && def) {
      return {
        title: `<a href="${href}" target="_blank">${title}</a>`,
        def
      };
    }
  }).filter(r => r);

  if (result.length > 0) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 43 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);

const MP3URI = 'https://fs-gateway.eudic.net/store_main/sentencemp3/';

function search(text, config, { AUDIO }) {
  let words = text.trim().split(/ +/);
  if (words.length > 2) {
    text = words.slice(0, 2).join(' ');
  }

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('https://dict.eudic.net/dicts/en/' + text).then(handleDom).then(result => {
    if (config.autopron.en.dict === 'eudic') {
      setTimeout(() => {
        result.some(({ mp3 }) => {
          if (mp3) {
            AUDIO.play(mp3);
            return true;
          }
        });
      }, 0);
    }
    return result;
  });
}

function handleDom(doc) {
  if (doc.querySelector('#TingLiju')) {
    return getResult(doc);
  }

  let status = doc.querySelector('#page-status');
  if (!status || !status.value) {
    return Promise.reject('no result');
  }

  let formData = new FormData();
  formData.append('status', status.value);

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('https://dict.eudic.net/Dicts/en/tab-detail/-12', { method: 'POST', body: formData }).then(getResult);
}

function getResult(doc) {
  let result = [];

  let items = doc.querySelectorAll('#lj_ting .lj_item');

  items.forEach(item => {
    let obj = {};

    let cover = item.querySelector('.channel img');
    if (cover) {
      obj.cover = cover.src;
    }


    let channel = item.querySelector('.channel_title');
    if (channel) {
      obj.channel = channel.innerText;
    }

    let audio = item.getAttribute('source');
    if (audio) {
      obj.mp3 = MP3URI + audio + '.mp3';
    }

    let en = item.querySelector('.line');
    if (en) {
      obj.en = en.innerText;
    }

    let chs = item.querySelector('.exp');
    if (chs) {
      obj.chs = chs.innerText;
    }

    if (Object.keys(obj).length > 0) {
      result.push(obj);
    }
  });

  if (result.length > 0) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 44 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_lang_check__ = __webpack_require__(12);


function search(text, config) {
  let url = 'https://translate.googleapis.com/translate_a/single?client=gtx&sl=auto&tl=zh-CN&dt=t&q=';

  if (Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_lang_check__["a" /* isContainChinese */])(text)) {
    url = 'https://translate.googleapis.com/translate_a/single?client=gtx&sl=zh-CN&tl=en&dt=t&q=';
  } else if (Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_lang_check__["b" /* isContainEnglish */])(text)) {
    url = 'https://translate.googleapis.com/translate_a/single?client=gtx&sl=en&tl=zh-CN&dt=t&q=';
  }

  return fetch(url + text).then(r => r.text()).then(handleText);
}

function handleText(text) {
  let json = JSON.parse(text.replace(/,+/g, ','));

  if (!json[0] || json[0].length <= 0) {
    return Promise.reject('no result');
  }

  let result = json[0].map(item => item[0]).join(' ');

  if (result.length > 0) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 45 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chs_to_chz__ = __webpack_require__(20);


function search(text, config, { AUDIO }) {
  return fetch(`https://www.moedict.tw/a/${Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chs_to_chz__["a" /* default */])(text)}.json`).then(res => res.json()).then(data => {
    if (!data) {
      return Promise.reject('no result');
    }
    data.h.forEach(h => {
      if (h['=']) {
        h['='] = `https://203146b5091e8f0aafda-15d41c68795720c6e932125f5ace0c70.ssl.cf1.rackcdn.com/${h['=']}.ogg`;
      }
    });
    return data;
  }).then(result => {
    if (config.autopron.cn.dict === 'guoyu') {
      setTimeout(() => {
        result.h.some(h => {
          if (h['=']) {
            AUDIO.play(h['=']);
            return true;
          }
        });
      }, 0);
    }
    return result;
  });
}

/***/ }),
/* 46 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);

const MP3URI = 'http://www.howjsay.com/mp3/';

function search(text, config, { AUDIO }) {
  const options = config.dicts.all.howjsay.options;

  let words = text.trim().split(/ +/);
  if (words.length > 2) {
    text = words.slice(0, 2).join(' ');
  }

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.howjsay.com/index.php?word=' + text).then(doc => handleDom(doc, text, options)).then(result => {
    if (config.autopron.en.dict === 'howjsay') {
      setTimeout(() => {
        AUDIO.play(result.currentWord.mp3);
      }, 0);
    }
    return result;
  });
}

function handleDom(doc, text, options) {
  let result = {
    currentWord: {
      title: text,
      mp3: ''
    }
  };

  let currentWord = doc.querySelector('#currentWord');
  if (currentWord && currentWord.value) {
    result.currentWord.title = currentWord.value;
    result.currentWord.mp3 = MP3URI + currentWord.value + '.mp3';
  }

  if (options.related) {
    result.relatedWords = Array.from(doc.querySelectorAll('.linksres')).map(el => {
      const title = el.innerText.trim();
      return {
        title,
        mp3: MP3URI + title + '.mp3'
      };
    });
  }

  if (result.currentWord.mp3) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 47 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_chs_to_chz__ = __webpack_require__(20);


function search(text, config) {
  return fetch(`https://www.moedict.tw/c/${Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_chs_to_chz__["a" /* default */])(text)}.json`).then(res => res.json()).then(data => {
    if (!data) {
      return Promise.reject('no result');
    }
    data.h.forEach(h => {
      if (h.p) {
        h.p = h.p.replace('<br>陸⃝', ' [大陆]: ');
      }
    });
    return data;
  });
}

/***/ }),
/* 48 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_src_helpers_promise_more__ = __webpack_require__(16);




function search(text, config, { AUDIO }) {
  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.macmillandictionary.com/dictionary/british/' + text.replace(/[^A-Za-z0-9]+/g, '-')).then(checkResult).then(addRelated).then(handleAllDom).then(result => {
    if (config.autopron.en.dict === 'macmillan') {
      setTimeout(() => {
        if (result.audio) {
          AUDIO.play(result.audio);
        } else {
          result.some(({ audio }) => {
            if (audio) {
              AUDIO.play(audio);
            }
          });
        }
      }, 0);
    }
    return result;
  });
}

function checkResult(doc) {
  if (doc.querySelector('.senses .SENSE')) {
    return doc;
  } else {
    let alternative = doc.querySelector('#search-results li a');
    if (alternative) {
      return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])(alternative.href);
    }
  }
  return Promise.reject('no result');
}

function addRelated(doc) {
  let $link = doc.querySelector('[rel="canonical"]');
  if (!$link) {
    return [doc];
  }

  let keyword = (/[^/]+(?=_\d+$)/.exec($link.href) || [''])[0];
  if (!keyword) {
    return [doc];
  }

  let keywordTester = new RegExp(keyword + '_\\d+$');
  let $related = Array.from(doc.querySelectorAll('#relatedentries li a')).filter(a => keywordTester.test(a.href));
  if ($related.length <= 0) {
    return [doc];
  }

  return Object(__WEBPACK_IMPORTED_MODULE_2_src_helpers_promise_more__["a" /* promiseReflect */])($related.map(a => Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])(a.href))).then(docs => [doc].concat(docs.filter(d => d)));
}

function handleAllDom(docs) {
  let result = docs.map(handleDom).filter(x => x);
  if (result.length > 0) {
    return result;
  }
  return Promise.reject('no result');
}

function handleDom(doc) {
  let def = {};

  let $title = doc.querySelector('#headword .BASE');
  if ($title) {
    def.title = $title.innerText;
  }

  let $headbar = doc.querySelector('#headbar');

  let $pos = $headbar.querySelector('.PART-OF-SPEECH');
  if ($pos) {
    def.pos = $pos.innerText;
  }

  let $sc = $headbar.querySelector('.SYNTAX-CODING');
  if ($sc) {
    def.sc = $sc.innerText;
  }

  let $pron = $headbar.querySelector('.PRON');
  if ($pron) {
    def.phsym = $pron.innerText;
  }

  let $sound = $headbar.querySelector('.PRONS .sound');
  if ($sound && $sound.dataset.srcMp3) {
    def.audio = $sound.dataset.srcMp3;
  }

  let $rate = doc.querySelector('.stars_grp');
  if ($rate) {
    def.star = $rate.querySelectorAll('.icon_star').length;
  }

  let $senses = doc.querySelectorAll('.senses .SENSE');
  if ($senses.length > 0) {
    def.senses = Array.from($senses).map(el => Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])(el).innerHTML);
  }

  if (Object.keys(def).length > 0) {
    return def;
  }

  return null;
}

/***/ }),
/* 49 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);


function search(text, config, { AUDIO }) {
  const options = config.dicts.all.urban.options;

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.urbandictionary.com/define.php?term=' + text).then(doc => handleDom(doc, options)).then(result => {
    if (config.autopron.en.dict === 'urban') {
      setTimeout(() => {
        result.some(({ pron }) => {
          if (pron) {
            AUDIO.play(pron);
            return true;
          }
        });
      }, 0);
    }
    return result;
  });
}

function handleDom(doc, { resultnum }) {
  let result = [];
  let defPanels = Array.from(doc.querySelectorAll('.def-panel'));

  if (defPanels.length <= 0) {
    return Promise.reject('no result');
  }

  defPanels.every($panel => {
    if (result.length >= resultnum) {
      return false;
    }

    let resultItem = {};

    let $title = $panel.querySelector('.word');
    if ($title) {
      resultItem.title = $title.innerText;
    }

    let $pron = $panel.querySelector('.play-sound');
    if ($pron) {
      resultItem.pron = JSON.parse($pron.dataset.urls)[0];
    }

    let $meaning = $panel.querySelector('.meaning');
    if ($meaning) {
      resultItem.meaning = $meaning.innerText;
      if (/There aren't any definitions for/i.test(resultItem.meaning)) {
        return true;
      }
    }

    let $example = $panel.querySelector('.example');
    if ($example) {
      resultItem.example = $example.innerText;
    }

    let $tags = Array.from($panel.querySelectorAll('.tags a'));
    if ($tags && $tags.length > 0) {
      resultItem.tags = $tags.map($tag => $tag.innerText.slice(1));
    }

    let $contributor = $panel.querySelector('.contributor');
    if ($contributor) {
      resultItem.contributor = $contributor.innerText;
    }

    let $thumbsUp = $panel.querySelector('.thumbs .up .count');
    if ($thumbsUp) {
      resultItem.thumbsUp = $thumbsUp.innerText;
    }

    let $thumbsDown = $panel.querySelector('.thumbs .down .count');
    if ($thumbsDown) {
      resultItem.thumbsDown = $thumbsDown.innerText;
    }

    if (Object.keys(resultItem).length > 0) {
      result.push(resultItem);
    }

    return true;
  });

  if (result.length > 0) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 50 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);


function search(text, config) {
  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('https://www.vocabulary.com/dictionary/' + text).then(handleDom);
}

function handleDom(doc) {
  let result = {};

  let $short = doc.querySelector('.short');
  if ($short) {
    result.short = $short.innerText;
  }

  let $long = doc.querySelector('.long');
  if ($long) {
    result.long = $long.innerText;
  }

  if (Object.keys(result).length > 0) {
    return result;
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 51 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);


function search(text, config) {
  const options = config.dicts.all.wordreference.options;

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])('http://www.wordreference.com/definition/' + text).then(doc => handleDom(doc, options));
}

function handleDom(doc, options) {
  let result = {};

  if (options.idiom) {
    let $idioms = Array.from(doc.querySelectorAll('.rh_idib li'));
    if ($idioms.length > 0) {
      result.idioms = $idioms.map(el => el.innerText);
    }
  }

  if (options.etym) {
    let $etym = doc.querySelector('.etyUl');
    if ($etym) {
      result.etym = $etym.innerText;
    }
  }

  if (Object.keys(result).length > 0) {
    return Promise.resolve(result);
  } else {
    return Promise.reject('no result');
  }
}

/***/ }),
/* 52 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (immutable) */ __webpack_exports__["default"] = search;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__ = __webpack_require__(11);



function search(text, config, { AUDIO }) {
  const options = config.dicts.all.bing.options;
  const SEARCH_LINK = 'http://www.zdic.net/search/?c=3&q=';
  text = text.trim();

  return Object(__WEBPACK_IMPORTED_MODULE_0_src_helpers_fetch_dom__["a" /* default */])(SEARCH_LINK + text).then(cleanDom).then(doc => {
    if (doc.querySelector('#tagContent0')) {
      return handleWord(doc, options);
    } else {
      return handlePhrase(doc, options);
    }
  }).then(result => {
    if (config.autopron.cn.dict === 'zdic') {
      setTimeout(() => {
        if (result.phsym && result.phsym[0] && result.phsym[0].pron) {
          AUDIO.play(result.phsym[0].pron);
        }
      }, 0);
    }
    return result;
  });
}

function handleWord(doc, options) {
  var result = {
    phsym: []
  };
  const $content = doc.querySelector('#tagContent0');
  const $zui = $content.querySelector('.zui');
  if ($zui) {
    $zui.querySelectorAll('.dicpy a').forEach($a => {
      result.phsym.push({
        pinyin: $a.innerText.trim(),
        pron: `http://www.zdic.net/p/mp3/${($a.href.match(/[^=]+$/) || [''])[0]}.mp3`
      });
    });
    $zui.remove();
  }

  const $diczx7 = $content.querySelector('.diczx7');
  if ($diczx7) {
    $diczx7.parentElement.remove();
  }
  const $diczx6 = $content.querySelector('.diczx6');
  if ($diczx6) {
    $diczx6.parentElement.remove();
  }

  $content.querySelectorAll('script').forEach(el => el.remove());

  $content.querySelectorAll('.dichr').forEach($hr => {
    $hr.previousElementSibling.classList.add('zdic-header');
  });
  result.html = Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])($content).innerHTML;

  return result;
}

function handlePhrase(doc, options) {
  const result = {};
  const $cdnr = doc.querySelector('.cdnr');

  $cdnr.querySelectorAll('script').forEach(el => {
    if (!result.phsym) {
      const p = el.innerText.match(/\("(.*)"\)/);
      if (p) {
        const $pinyins = $cdnr.querySelector('.dicpy');
        if ($pinyins) {
          const prons = p[1].split(' ');
          const pinyins = $pinyins.innerText.trim().split(' ');
          if (prons.length === pinyins.length) {
            result.phsym = pinyins.map((pinyin, i) => ({
              pinyin,
              pron: `http://www.zdic.net/p/mp3/${prons[i]}.mp3`
            }));
          }
        }
      }
    }
    el.remove();
  });
  result.html = Object(__WEBPACK_IMPORTED_MODULE_1_src_helpers_strip_script__["a" /* default */])($cdnr).innerHTML;
  return result;
}

function cleanDom(doc) {
  const testStyle = /\.(\S+)(?=\s?\{\s*display\s?:\s?none)/ig;
  doc.querySelectorAll('style').forEach($style => {
    ($style.innerText.match(testStyle) || []).forEach(className => {
      doc.querySelectorAll(className).forEach($junkClass => $junkClass.remove());
    });
  });

  return doc;
}

/***/ })
/******/ ]);
//# sourceMappingURL=server.js.map